#    DamBASE - Dam Behaviour Analysis Software Environment
#    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
#    Vetsch D.F., 2015
#    http://www.dambase.ethz.ch
#
#    This file is part of DamBASE
#
#    DamBASE is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    DamBASE is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#
#can be used everywhere else (TODO rename)
#this code has been derive from dambase 1.0 written by Dr.Benedikt Weber
dambase.convolution <-
  function(x, t, kernel) {
    n <- length(x)
    tmp = NULL
    tmp[1] <- 0
    
    i <- 1
    while(i < n) {
      sum <- 0
      f1=NULL
      f2=x[i+1]*kernel[1]
      nkernel <- length(kernel)
      tk1=NULL
      tk2 <- 0
      
      k<-i
      while(k > 0) {
        tk1 <- tk2
        tk2 <- t[i+1]-t[k-1+1]
        if(tk2 >= nkernel) break
        f1 <- f2
        f2 <- x[k-1+1]*kernel[tk2+1]
        sum <- sum + (f1+f2)*0.5*(tk2-tk1);
        
        k <- k-1
      }
      tmp[i+1] <- sum
      
      
      i <- i+1
    }
    
    return(tmp)
  }