#    DamBASE - Dam Behaviour Analysis Software Environment
#    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
#    Vetsch D.F., 2015
#    http://www.dambase.ethz.ch
#
#    This file is part of DamBASE
#
#    DamBASE is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    DamBASE is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#
dambase.drift.exp <- 
function(dateColumn, divisor=1) {
  normalized <- c((dateColumn[1:length(dateColumn)] - dateColumn[1])/365.25)
  return(exp((normalized*-1) / divisor))
}

dambase.drift.sqrt <-
function(dateColumn) {
  normalized <- c((dateColumn[1:length(dateColumn)] - dateColumn[1])/365.25)
  return(sqrt(normalized))
}

dambase.drift.ln <-
function(dateColumn) {
  normalized <- c((dateColumn[1:length(dateColumn)] - dateColumn[1])/365.25)
  return(log(1+normalized))
}

dambase.drift.power <-
function(dateColumn, power) {
  normalized <- c((dateColumn[1:length(dateColumn)] - dateColumn[1])/365.25)
  
  return(normalized^power)
}