#    DamBASE - Dam Behaviour Analysis Software Environment
#    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
#    Vetsch D.F., 2015
#    http://www.dambase.ethz.ch
#
#    This file is part of DamBASE
#
#    DamBASE is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    DamBASE is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#
dambase.extra.sqrtramp <- 
function(column, subtrahend=100) {
  values <- sqrt(dambase.ramp(column-subtrahend))
  return(values)
}

dambase.extra.columntimesstep <-
function(column, subtrahend=100) {
  values <- column * dambase.step(column - subtrahend)
  return(values)
}

dambase.extra.spline <-
function(column, x, y) {
  f <- splinefun(x, y)
  return(f(column))
}


dambase.ramp <-
function (column) {
  values <- sapply(column, function(x) ifelse(x >= 0 , x, 0))
  return(values)
}

dambase.step <-
function(column) {
  message("dambase.step[1] : ", any(is.na(column)))
  values <- sapply(column, function(x) ifelse(x >= 0, 1, 0))
  message("dambase.step[2] : ", any(is.na(column)))
  return(values)
}