#    DamBASE - Dam Behaviour Analysis Software Environment
#    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
#    Vetsch D.F., 2015
#    http://www.dambase.ethz.ch
#
#    This file is part of DamBASE
#
#    DamBASE is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    DamBASE is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#
# this function has been derived from base::scale in order to add
# phase dependent behavior
phasedScale <- function (x, container)  # scale=FALSE, center=TRUE
{
  message("phasedScale")
  x <- as.matrix(x)

  if(exists("phase",envir=baseenv()) && get(x="phase", envir=baseenv()) == "p") {
    center <- get(x="center", envir=container)
  }else if(exists("phase",envir=baseenv()) && get(x="phase", envir=baseenv()) == "c"){
    #core
    center <- colMeans(x, na.rm = TRUE)
    assign("center", value=center, envir=container)
  }
  
  x <- sweep(x, 2L, center, check.margin = FALSE)
  return(x)
}