/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * CoreApplicationContext.cpp
 *
 *  Created on: 13.02.2015
 *      Author: gerberma
 */

#include <boost/bind.hpp>
#include "app/CoreApplicationContext.hpp"

namespace app {
namespace context {

CoreApplicationContext::CoreApplicationContext():
		GAC_PARTIAL_CTOR_INIT_WITH_FACTORY(Core_Controller_t, boost::bind<Core_Controller_t *>(&CoreApplicationContext::fromRegisteredFactory<Core_Controller_t, App_Factory_t>, this)),
		GAC_PARTIAL_CTOR_INIT_WITH_FACTORY(Core_Window_t, boost::bind<Core_Window_t *>(&CoreApplicationContext::fromRegisteredFactory<Core_Window_t, App_Factory_t>, this)),
		GAC_DEFAULT_CTOR_INIT(Navigation_Tree_Widget_t),
		GAC_PARTIAL_CTOR_INIT_WITH_FACTORY(Model_t, boost::bind<Model_t *>(&CoreApplicationContext::fromRegisteredFactory<Model_t, App_Factory_t>, this)),
		GAC_PARTIAL_CTOR_INIT_WITH_FACTORY(DirectoryManager_t, boost::bind<DirectoryManager_t *>(&CoreApplicationContext::fromRegisteredFactory<DirectoryManager_t, App_Factory_t>, this)),
		GAC_DEFAULT_CTOR_INIT(Model_Factory_t),
		GAC_DEFAULT_CTOR_INIT(Analysis_Tools_Factory_t),
		GAC_PARTIAL_CTOR_INIT_WITH_FACTORY(AnalysisToolsControllerSubscriptionManager_t, boost::bind<AnalysisToolsControllerSubscriptionManager_t *>(&CoreApplicationContext::fromRegisteredFactory<AnalysisToolsControllerSubscriptionManager_t, App_Factory_t>, this))
{
}

CoreApplicationContext::~CoreApplicationContext() {
}

} /* namespace context */
} /* namespace app */
