/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * CoreRegressionModelSubscriptions3.cpp
 *
 *  Created on: 13.02.2015
 *      Author: gerberma
 */

#include <boost/foreach.hpp>
#include <boost/bind.hpp>
#include <boost/ref.hpp>
#include <boost/function.hpp>
#include <boost/bind/protect.hpp>
#include "app/types.hpp"
#include "app/GenericApplicationContext.hpp"
#include "communication/Signals.hpp"
#include "app/CoreRegressionModelSubscriptions3.hpp"

namespace app {

CoreRegressionModelSubscriptions3::CoreRegressionModelSubscriptions3() {
	// TODO Auto-generated constructor stub

}

CoreRegressionModelSubscriptions3::~CoreRegressionModelSubscriptions3() {
	using namespace boost;

	BOOST_FOREACH(signals2::connection &connection, subscriptionConnections) {
		connection.disconnect();
	}
}

void CoreRegressionModelSubscriptions3::subscribe() {
	using namespace context;
	using namespace boost;

	Navigation_Tree_Widget_t *navigationTreeWidget = FETCH_FROM_CTX(Navigation_Tree_Widget_t);

	/*
	subscriptionConnections.push_back(COM_SUBSCRIBE_FOR(navigationTreeWidget, CreateReport,
			(bind(&ReportController_t::createFor<Project_t, Analysis_t, RegressionModel_t, ReportSubscriptionManager_t>, FETCH_FROM_CTX(ReportController_t),
					_1, _2, _3,
					protect(bind((Report_t *(App_Factory_t::*)(boost::shared_ptr<Project_t>, boost::shared_ptr<Analysis_t>, boost::shared_ptr<RegressionModel_t>))&App_Factory_t::create<Report_t, Project_t, Analysis_t, RegressionModel_t>, FETCH_FROM_CTX(App_Factory_t), _1, _2, _3)), //this _1 is not the same as the 'outer' _1
					FETCH_FROM_CTX(ReportSubscriptionManager_t)
			))
	));
	*/

	subscriptionConnections.push_back(COM_SUBSCRIBE_FOR(navigationTreeWidget, CreateReport,
			(bind(&ReportController_t::createFor<Project_t, Analysis_t, RegressionModel_t, ReportSubscriptionManager_t>, FETCH_FROM_CTX(ReportController_t),
					_1, _2, _3,
					FETCH_FROM_CTX(ReportSubscriptionManager_t)
			))
	));


	subscriptionConnections.push_back(COM_SUBSCRIBE_FOR(navigationTreeWidget, CreateExport,
			(bind(&RawDataExportController_t::createExportRawDataFor<Project_t, Analysis_t, RegressionModel_t>, FETCH_FROM_CTX(RawDataExportController_t),
					_1, _2, _3,
					protect(bind((RawDataCollector_t *(App_Factory_t::*)())&App_Factory_t::create<RawDataCollector_t>, FETCH_FROM_CTX(App_Factory_t)))
			)
	)));
}

} /* namespace app */
