/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * ExceptionNotificationQApplication.cpp
 *
 *  Created on: Mar 7, 2014
 *      Author: gerberma
 */

#include <QDebug>
#include <QMessageBox>
#include "app/ExceptionNotificationQApplication.hpp"

namespace app {


ExceptionNotificationQApplication::ExceptionNotificationQApplication(int argc, char* argv[])
	:QApplication(argc, argv)
{;}

ExceptionNotificationQApplication::~ExceptionNotificationQApplication() {;}

bool ExceptionNotificationQApplication::notify(QObject* receiver, QEvent* event) {
	try {
		return QApplication::notify(receiver, event);
	}catch(std::exception& e) {
		qDebug() << "Exception thrown:" << e.what();
		QMessageBox(QMessageBox::Information, tr("Internal error"), e.what(), QMessageBox::Ok).exec();
	}

	return false;
}

} /* namespace app */
