/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * ExceptionPoliciesImpl.hpp
 *
 *  Created on: Nov 22, 2013
 *      Author: gerberma
 */

#ifndef EXCEPTIONPOLICIESIMPL_HPP_
#define EXCEPTIONPOLICIESIMPL_HPP_

#include "gui/InfoDialog.hpp"
//#include "model/Project.hpp"
//#include "model/AnalysisFwd.hpp"
#include "app/types.hpp"
#include <boost/shared_ptr.hpp>
#include "mpl/Type2Type.hpp"

namespace exceptionpolicies {

template<>
inline void ExceptionPolicy::handleSerializationException(mpl::Type2Type<Project_t >, QString &filename, const char *what) {
	QString reason(what);
	QString exceptionMessage = QObject::tr("Failed to save project to %1. Reason: %2").arg(filename).arg(reason);
	gui::InfoDialog::showException(exceptionMessage);
}

template<>
inline void ExceptionPolicy::handleDeserializationException(mpl::Type2Type<Project_t >, QString &filename, const char *what) {
	QString reason(what);
	QString exceptionMessage = QObject::tr("Failed to load project from %1. Reason: %2").arg(filename).arg(reason);
	gui::InfoDialog::showException(exceptionMessage);
}

template<typename T>
inline void exceptionpolicies::ExceptionPolicy::wrongCallOrder(boost::shared_ptr<T> t, QString first, QString second) {
	QString exceptionMessage = QObject::tr("Internal state error detected");
	gui::InfoDialog::showException(exceptionMessage);

	/* TODO: log exception */
}

} /* namespace exceptionpolicies */


#endif /* EXCEPTIONPOLICIESIMPL_HPP_ */
