/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * Factory.hpp
 *
 *  Created on: Dec 17, 2013
 *      Author: gerberma
 */

#ifndef FACTORY_HPP_
#define FACTORY_HPP_

#include <boost/shared_ptr.hpp>

namespace app {

class Factory {
public:
	Factory();
	virtual ~Factory();

	template<typename T>
	T *operator()();

	template<typename T>
	T *create();

	template<typename T, typename U>
	T *create(U *u);

	template<typename T, typename U>
	T *create(boost::shared_ptr<U> u);

	template<typename T, typename U>
	T *create(U &u);

/*
	template<typename T, typename U>
	T *create(U u);
*/

	template<typename T>
	T *create(int);

	template<typename T, typename U, typename W>
	T *create(U, W);

	template<typename T, typename U, typename W>
	T *create(U *, W);

	template<typename T, typename U, typename W>
	T *create(boost::shared_ptr<U>, W);

	template<typename T, typename U, typename W>
	T *create(U *, W *);

	template<typename T, typename U, typename W>
	T *create(boost::shared_ptr<U>, boost::shared_ptr<W>);

	template<typename T, typename U, typename W, typename X>
	T *create(U *, W *, X *);

	template<typename T, typename U, typename W, typename X>
	T *create(boost::shared_ptr<U>, boost::shared_ptr<W>, boost::shared_ptr<X>);

	template<typename T, typename U, typename W, typename X>
	T *create(boost::shared_ptr<U>, boost::shared_ptr<W>, boost::shared_ptr<X>, int);

	template<typename T, typename U, typename W, typename X>
	T *create(U *, W, X);

	template<typename T, typename U, typename W, typename X>
	T *create(boost::shared_ptr<U>, W, X);

	template<typename T, typename U, typename W, typename X>
	T *create(U *, W *, X);

	template<typename T, typename U, typename W, typename X>
	T *create(boost::shared_ptr<U>, boost::shared_ptr<W>, X);

	template<typename T, typename U, typename W, typename X, typename Y>
	T *create(U *, W *, X, Y);

	template<typename T, typename U, typename W, typename X, typename Y>
	T *create(boost::shared_ptr<U>, boost::shared_ptr<W>, X, Y);
};


}/* namespace app */

#endif /* FACTORY_HPP_ */
