/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * ReportApplicationContext.cpp
 *
 *  Created on: 13.02.2015
 *      Author: gerberma
 */

#include "app/ReportApplicationContext.hpp"

namespace app {
namespace context {

ReportApplicationContext::ReportApplicationContext():
		GAC_PARTIAL_CTOR_INIT_WITH_FACTORY(ReportUiManager_t, boost::bind<ReportUiManager_t *>(&ReportApplicationContext::fromRegisteredFactory<ReportUiManager_t, App_Factory_t>, this)),
		GAC_PARTIAL_CTOR_INIT_WITH_FACTORY(ReportSubscriptionManager_t, boost::bind<ReportSubscriptionManager_t *>(&ReportApplicationContext::fromRegisteredFactory<ReportSubscriptionManager_t, App_Factory_t>, this)),
		GAC_PARTIAL_CTOR_INIT_WITH_FACTORY(ReportInternalGenericController_t, boost::bind<ReportInternalGenericController_t *>(&ReportApplicationContext::fromRegisteredFactory<ReportInternalGenericController_t, App_Factory_t>, this)),
		GAC_PARTIAL_CTOR_INIT_WITH_FACTORY(ReportController_t, boost::bind<ReportController_t *>(&ReportApplicationContext::fromRegisteredFactory<ReportController_t, App_Factory_t>, this))
{
}

ReportApplicationContext::~ReportApplicationContext() {
	// TODO Auto-generated destructor stub
}

} /* namespace context */
} /* namespace app */
