/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * AnalysisUiFactory.cpp
 *
 *  Created on: Dec 3, 2013
 *      Author: gerberma
 */

#include <QObject>
#include <boost/shared_ptr.hpp>
#include "Factory.hpp"
#include "app/GenericApplicationContext.hpp"
#include "app/types.hpp"

using namespace app::context;

namespace app {


template<>
AnalysisToolRegressionFitAnalysisOverallRegressionQualityWidget_t *Factory::create<AnalysisToolRegressionFitAnalysisOverallRegressionQualityWidget_t, RegressionFitAnalysisOverallRegressionQuality_t>(boost::shared_ptr<RegressionFitAnalysisOverallRegressionQuality_t>) {
	return new AnalysisToolRegressionFitAnalysisOverallRegressionQualityWidget_t();
}

template<>
RegressionFitAnalysisOverallRegressionQualityDisplayWidget_t *Factory::create<RegressionFitAnalysisOverallRegressionQualityDisplayWidget_t, RegressionFitAnalysisOverallRegressionQuality_t>(boost::shared_ptr<RegressionFitAnalysisOverallRegressionQuality_t> quality) {
	return new RegressionFitAnalysisOverallRegressionQualityDisplayWidget_t(quality);
}

template<>
RegressionFitAnalysisOverallRegressionQualityUiManager_t *Factory::create<RegressionFitAnalysisOverallRegressionQualityUiManager_t>() {
	return new RegressionFitAnalysisOverallRegressionQualityUiManager_t(FETCH_FROM_CTX(Ui_Factory_t));
}



template<>
AnalysisToolRegressionFitAnalysisPhysicalBehaviorWidget_t *Factory::create<AnalysisToolRegressionFitAnalysisPhysicalBehaviorWidget_t, RegressionFitAnalysisPhysicalBehavior_t>(boost::shared_ptr<RegressionFitAnalysisPhysicalBehavior_t>) {
	return new AnalysisToolRegressionFitAnalysisPhysicalBehaviorWidget_t();
}

template<>
RegressionFitAnalysisPhysicalBehaviorDisplayWidget_t *Factory::create<RegressionFitAnalysisPhysicalBehaviorDisplayWidget_t, RegressionFitAnalysisPhysicalBehavior_t>(boost::shared_ptr<RegressionFitAnalysisPhysicalBehavior_t> t) {
	return new RegressionFitAnalysisPhysicalBehaviorDisplayWidget_t(t);
}

template<>
RegressionFitAnalysisPhysicalBehaviorUiManager_t *Factory::create<RegressionFitAnalysisPhysicalBehaviorUiManager_t>() {
	return new RegressionFitAnalysisPhysicalBehaviorUiManager_t(FETCH_FROM_CTX(Ui_Factory_t));
}



template<>
AnalysisToolRegressionFitAnalysisRegressorTimeseriesWidget_t *Factory::create<AnalysisToolRegressionFitAnalysisRegressorTimeseriesWidget_t, RegressionFitAnalysisRegressorTimeseries_t>(boost::shared_ptr<RegressionFitAnalysisRegressorTimeseries_t>) {
	return new AnalysisToolRegressionFitAnalysisRegressorTimeseriesWidget_t();
}

template<>
RegressionFitAnalysisRegressorTimeseriesDisplayWidget_t *Factory::create<RegressionFitAnalysisRegressorTimeseriesDisplayWidget_t, RegressionFitAnalysisRegressorTimeseries_t>(boost::shared_ptr<RegressionFitAnalysisRegressorTimeseries_t> t) {
	return new RegressionFitAnalysisRegressorTimeseriesDisplayWidget_t(t);
}

template<>
RegressionFitAnalysisRegressorTimeseriesUiManager_t *Factory::create<RegressionFitAnalysisRegressorTimeseriesUiManager_t>() {
	return new RegressionFitAnalysisRegressorTimeseriesUiManager_t(FETCH_FROM_CTX(Ui_Factory_t));
}

} /* namespace app */


