/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * AnalysisUiFactory.cpp
 *
 *  Created on: Dec 3, 2013
 *      Author: gerberma
 */

#include <boost/shared_ptr.hpp>
#include "Factory.hpp"
#include "app/GenericApplicationContext.hpp"
#include "app/types.hpp"

using namespace app::context;

namespace app {


/****************************
 * Regression model related *
 ****************************/

template<>
RegressorInfluenceFactorInstantiationMessageDialog_t *Factory::create<RegressorInfluenceFactorInstantiationMessageDialog_t, Regressor_t>(boost::shared_ptr<Regressor_t> regressor) {
	return new RegressorInfluenceFactorInstantiationMessageDialog_t(regressor);
}

template<>
RegressorInfluenceFactorSelectionWidget_t *Factory::create<RegressorInfluenceFactorSelectionWidget_t, Regressor_t>(boost::shared_ptr<Regressor_t> regressor) {
	return new RegressorInfluenceFactorSelectionWidget_t(regressor);
}

template<>
RegressionModelDefinitionEditWidget_t *Factory::create<RegressionModelDefinitionEditWidget_t, Regression_Formula_t, RegressionModelDefinition_t>(boost::shared_ptr<Regression_Formula_t> regressionFormula, boost::shared_ptr<RegressionModelDefinition_t> regressionModelDefinition) {
	return new RegressionModelDefinitionEditWidget_t(regressionFormula, regressionModelDefinition);
}

template<>
RegressorFormulaBuilderEditWidget_t *Factory::create<RegressorFormulaBuilderEditWidget_t, ExpressionRegressorFormulaBuilder_t>(boost::shared_ptr<ExpressionRegressorFormulaBuilder_t> regressorFormulaBuilder) {
	return new RegressorFormulaBuilderEditWidget_t(regressorFormulaBuilder);
}

} /* namespace app */


