/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * AnalysisUiFactory.cpp
 *
 *  Created on: Dec 3, 2013
 *      Author: gerberma
 */

#include <boost/shared_ptr.hpp>
#include "Factory.hpp"
#include "app/GenericApplicationContext.hpp"
#include "app/types.hpp"

using namespace app::context;

namespace app {


/****************************
 * Regression model related *
 ****************************/

template<>
UserParameterNameWidget_t *Factory::create<UserParameterNameWidget_t>(boost::shared_ptr<ExpressionRegressorFormulaBuilder_t>) {
	return new UserParameterNameWidget_t(QObject::tr("Parameter"), QObject::tr("Please define a unique parameter name"));
}

template<>
RegressionModel_Wizard_t *Factory::create<RegressionModel_Wizard_t, RegressionModel_t>(boost::shared_ptr<RegressionModel_t> regressionModel) {
	return new RegressionModel_Wizard_t(regressionModel);
}

template<>
RegressionModel_Common_Parameter_Display_Widget_t *Factory::create<RegressionModel_Common_Parameter_Display_Widget_t, RegressionModel_t>(boost::shared_ptr<RegressionModel_t> regressionModel) {
	return new RegressionModel_Common_Parameter_Display_Widget_t(regressionModel);
}

template<>
RegressionModel_Time_Range_Display_Widget_t *Factory::create<RegressionModel_Time_Range_Display_Widget_t, RegressionModel_t>(boost::shared_ptr<RegressionModel_t> regressionModel) {
	return new RegressionModel_Time_Range_Display_Widget_t(regressionModel);
}

} /* namespace app */


