/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * ReportFactoryImpl.cpp
 *
 *  Created on: Jul 10, 2014
 *      Author: gerberma
 */


#include <boost/shared_ptr.hpp>
#include "app/GenericApplicationContext.hpp"
#include "app/Factory.hpp"
#include "app/types.hpp"

#include "model/Report.hpp"

namespace app {

template<>
Report_t *Factory::create<Report_t, Project_t, Analysis_t, RegressionModel_t>(boost::shared_ptr<Project_t> project, boost::shared_ptr<Analysis_t> analysis, boost::shared_ptr<RegressionModel_t> regressionModel) {
	using namespace dambase::model;

	return new Report(
				project, analysis, regressionModel,
				//FETCH_FROM_CTX(ReportListElementFactory_t),
				FETCH_FROM_CTX(DirectoryManager_t)->getTemporaryDirectory(),
				"PDF (*.pdf);; Microsoft Word (*.docx);; Open Office (*.odt);; Rich Text (*.rtf);; Text (*.txt)"
			);
}

} // namespace app
