/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * startup.cpp
 *
 *  Created on: Dec 19, 2013
 *      Author: gerberma
 */

#include <QApplication>
#include <QProcess>
#include <QDir>
#include <iostream>
#include "StartupRunner.hpp"


int
main(int argc, char *argv[]) {
	QCoreApplication app(argc, argv);
	app::Runner *runner = new app::Runner(&app);
	QProcess *dambase = new QProcess(&app);

	QProcessEnvironment processEnvironment = QProcessEnvironment::systemEnvironment();
	processEnvironment.insert("R_HOME", ".");

	std::cerr << processEnvironment.value("PATH").toStdString() << std::endl;
	QString currentPath = processEnvironment.value("PATH");
	currentPath = currentPath + ";" + QApplication::applicationDirPath() + "/reporting/pandoc";
	currentPath = currentPath + ";" + QApplication::applicationDirPath() + "/reporting/miktexportable/miktex/bin";
	currentPath = QDir::toNativeSeparators(currentPath);
	processEnvironment.insert("PATH", currentPath);
	//damreg->setEnvironment()
	dambase->setProcessEnvironment(processEnvironment);

	std::cerr << processEnvironment.value("PATH").toStdString() << std::endl;

	QApplication::connect(dambase, SIGNAL(finished(int)), runner, SLOT(terminate(int)));

	dambase->start("DamBASE_v_CURRENT_DAMBASE_VERSION_.exe", app.arguments());

	return app.exec();
}
