/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * DataModelAnalysisInfluenceFactorsControllerSubscriptionManager.hpp
 *
 *  Created on: Feb 4, 2014
 *      Author: gerberma
 */

#ifndef DATAMODELANALYSISINFLUENCEFACTORSCONTROLLERSUBSCRIPTIONMANAGER_HPP_
#define DATAMODELANALYSISINFLUENCEFACTORSCONTROLLERSUBSCRIPTIONMANAGER_HPP_

#include "communication/Signals.hpp"
#include <boost/bind.hpp>
#include <boost/function.hpp>
#include <boost/shared_ptr.hpp>

namespace controller {

class DataModelAnalysisInfluenceFactorsControllerSubscriptionManager {
public:
	DataModelAnalysisInfluenceFactorsControllerSubscriptionManager();
	virtual ~DataModelAnalysisInfluenceFactorsControllerSubscriptionManager();

	template<typename OverviewUi, typename Controller, typename Analysis>
	void subscribeOverviewUi(OverviewUi *overviewUi, Controller *controller, boost::shared_ptr<Analysis> analysis);
};

inline DataModelAnalysisInfluenceFactorsControllerSubscriptionManager::DataModelAnalysisInfluenceFactorsControllerSubscriptionManager() {
}

inline DataModelAnalysisInfluenceFactorsControllerSubscriptionManager::~DataModelAnalysisInfluenceFactorsControllerSubscriptionManager() {
}


template<typename OverviewUi, typename Controller, typename Analysis>
inline void controller::DataModelAnalysisInfluenceFactorsControllerSubscriptionManager::subscribeOverviewUi(OverviewUi* overviewUi, Controller* controller, boost::shared_ptr<Analysis> analysis) {
	using namespace boost;
	COM_SUBSCRIBE_FOR(overviewUi, BehaviorIndicatorChanged, (bind(&Controller::behaviorIndicatorChanged, controller, _1, _2)));
	COM_SUBSCRIBE_FOR(overviewUi, InfluenceFactorChanged, (bind(&Controller::influenceFactorChanged, controller, _1, _2)));

	COM_SUBSCRIBE_FOR(overviewUi, RemoveAnalysisTool, (bind(&Controller::removeAnalysisTool, controller, analysis, _1)));
}

} /* namespace controller */

#endif /* DATAMODELANALYSISINFLUENCEFACTORSCONTROLLERSUBSCRIPTIONMANAGER_HPP_ */
