/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * DataModelAnalysisOverviewSummaryControllerSubscriptionManager.hpp
 *
 *  Created on: Jan 31, 2014
 *      Author: gerberma
 */

#ifndef DATAMODELANALYSISOVERVIEWSUMMARYCONTROLLERSUBSCRIPTIONMANAGER_HPP_
#define DATAMODELANALYSISOVERVIEWSUMMARYCONTROLLERSUBSCRIPTIONMANAGER_HPP_

#include <boost/shared_ptr.hpp>
#include "communication/Signals.hpp"

namespace controller {

class DataModelAnalysisOverviewSummaryControllerSubscriptionManager {
public:
	DataModelAnalysisOverviewSummaryControllerSubscriptionManager();
	virtual ~DataModelAnalysisOverviewSummaryControllerSubscriptionManager();

	template<typename OverviewUi, typename Controller, typename Analysis>
	void subscribeOverviewUi(OverviewUi *overviewUi, Controller *controller, boost::shared_ptr<Analysis> analysis);
};

inline DataModelAnalysisOverviewSummaryControllerSubscriptionManager::DataModelAnalysisOverviewSummaryControllerSubscriptionManager() {
}

inline DataModelAnalysisOverviewSummaryControllerSubscriptionManager::~DataModelAnalysisOverviewSummaryControllerSubscriptionManager() {
}


template
<
	typename OverviewUi,
	typename Controller,
	typename Analysis
>
inline void controller::DataModelAnalysisOverviewSummaryControllerSubscriptionManager::subscribeOverviewUi(OverviewUi* overviewUi, Controller* controller, boost::shared_ptr<Analysis> analysis) {
	COM_SUBSCRIBE_FOR(overviewUi, RemoveAnalysisTool, (bind(&Controller::removeAnalysisTool, controller, analysis, _1)));
}

} /* namespace controller */

#endif /* DATAMODELANALYSISOVERVIEWSUMMARYCONTROLLERSUBSCRIPTIONMANAGER_HPP_ */
