/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * DataModelAnalysisToolsControllerDispatcher.hpp
 *
 *  Created on: Jan 31, 2014
 *      Author: gerberma
 */

#ifndef DATAMODELANALYSISTOOLSCONTROLLERDISPATCHER_HPP_
#define DATAMODELANALYSISTOOLSCONTROLLERDISPATCHER_HPP_

#include <boost/function.hpp>
#include <boost/shared_ptr.hpp>

namespace controller {

class DataModelAnalysisToolsControllerDispatcher {
public:
	DataModelAnalysisToolsControllerDispatcher();
	virtual ~DataModelAnalysisToolsControllerDispatcher();

	template<typename Analysis, typename AnalysisToolDescription, typename BaseUiType> //BaseUiType might be QWidget (something the dispatch function function paramter uiLocation can handle)
	boost::function<void()> dispatch(boost::shared_ptr<Analysis> analysis, boost::shared_ptr<AnalysisToolDescription> analysisToolDescription, boost::function<void(BaseUiType *)> uiLocation);
};

} /* namespace controller */

#endif /* DATAMODELANALYSISTOOLSCONTROLLERDISPATCHER_HPP_ */
