/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * ExceptionPolicies.hpp
 *
 *  Created on: Nov 22, 2013
 *      Author: gerberma
 */

#ifndef EXCEPTIONPOLICIES_HPP_
#define EXCEPTIONPOLICIES_HPP_

#include <iostream>
#include <QString>
#include <QObject>
#include <boost/shared_ptr.hpp>

namespace exceptionpolicies {

class ExceptionPolicy {
public:
	ExceptionPolicy(){}
	virtual ~ExceptionPolicy(){}

	template<typename T>
	static void handleSerializationException(T t, QString &filename, const char *what);

	template<typename T>
	static void handleDeserializationException(T t, QString &filename, const char *what);

	template<typename T>
	static void wrongCallOrder(boost::shared_ptr<T> t, QString first, QString second);
};

} /* namespace exceptionpolicies */

#endif /* EXCEPTIONPOLICIES_HPP_ */
