/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * AnalysisCategoryProvider.hpp
 *
 *  Created on: Mar 7, 2014
 *      Author: gerberma
 */

#ifndef ANALYSISCATEGORYPROVIDER_HPP_
#define ANALYSISCATEGORYPROVIDER_HPP_

#include <QObject>
#include <boost/shared_ptr.hpp>

namespace gui {

template<typename AnalysisToolsDescription>
class AnalysisCategoryProvider : public QObject {
public:
	typedef typename AnalysisToolsDescription::tool_description_t tool_description_t;
	typedef typename AnalysisToolsDescription::container_t container_t;

public:
	AnalysisCategoryProvider(boost::shared_ptr<AnalysisToolsDescription> analysisToolsDescription, QObject *parent = 0)
		:QObject(parent), analysisToolsDescription(analysisToolsDescription) {}
	virtual ~AnalysisCategoryProvider(){}

	boost::shared_ptr<AnalysisToolsDescription> getAnalysisToolsDescription() {
		return analysisToolsDescription;
	}

private:
	boost::shared_ptr<AnalysisToolsDescription> analysisToolsDescription;
};

}  // namespace gui



#endif /* ANALYSISCATEGORYPROVIDER_HPP_ */
