/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * AnalysisToolWidget.hpp
 *
 *  Created on: Feb 5, 2014
 *      Author: gerberma
 */

#ifndef ANALYSISTOOLWIDGET_HPP_
#define ANALYSISTOOLWIDGET_HPP_

#include <QWidget>
#include "AnalysisToolToolBar.hpp"
#include "communication/Signals.hpp"

namespace gui {

class AnalysisToolWidget : public QWidget {
public:
	AnalysisToolWidget(QWidget *parent = 0);
	virtual ~AnalysisToolWidget();

//protected:
	AnalysisToolToolBar *getToolBar();

private:
	void setupLayout();

private:
	AnalysisToolToolBar *toolBar;
};

inline AnalysisToolWidget::AnalysisToolWidget(QWidget* parent)
	:QWidget(parent)
{
	setupLayout();
}

inline AnalysisToolWidget::~AnalysisToolWidget() {
}

inline AnalysisToolToolBar* AnalysisToolWidget::getToolBar() {
	return toolBar;
}

inline void AnalysisToolWidget::setupLayout() {
	toolBar = new AnalysisToolToolBar(this);
}

} /* namespace gui */

#endif /* ANALYSISTOOLWIDGET_HPP_ */
