/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * DataModelAnalysisDistributionCategoryProvider.hpp
 *
 *  Created on: Jan 21, 2014
 *      Author: gerberma
 */

#ifndef DATAMODELANALYSISDISTRIBUTIONCATEGORYPROVIDER_HPP_
#define DATAMODELANALYSISDISTRIBUTIONCATEGORYPROVIDER_HPP_

#include <boost/shared_ptr.hpp>
#include "AnalysisCategoryProvider.hpp"

namespace gui {

template<typename AnalysisToolsDescription>
class DataModelAnalysisDistributionCategoryProvider : public AnalysisCategoryProvider<AnalysisToolsDescription> {
public:
	DataModelAnalysisDistributionCategoryProvider(boost::shared_ptr<AnalysisToolsDescription> analysisToolsDescription, QObject *parent = 0)
		:AnalysisCategoryProvider<AnalysisToolsDescription>(analysisToolsDescription, parent)
	{;}
	virtual ~DataModelAnalysisDistributionCategoryProvider(){}

	typename AnalysisToolsDescription::container_t getCategoryRelatedAnalysisToolsDescription() {
		return AnalysisCategoryProvider<AnalysisToolsDescription>::getAnalysisToolsDescription()->getDistributionAnalysisToolsDescription();
	}

	QString getCategoryName() {
		return QObject::tr("Distribution");
	}
};

} /* namespace gui */


#endif /* DATAMODELANALYSISDISTRIBUTIONCATEGORYPROVIDER_HPP_ */
