/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * DataModelBehaviorIndicatorAssignmentDisplayProvider.hpp
 *
 *  Created on: Jan 15, 2014
 *      Author: gerberma
 */

#ifndef DATAMODELBEHAVIORINDICATORASSIGNMENTDISPLAYPROVIDER_HPP_
#define DATAMODELBEHAVIORINDICATORASSIGNMENTDISPLAYPROVIDER_HPP_

#include <QObject>
#include <boost/shared_ptr.hpp>

namespace gui {

template<typename DataModel>
class DataModelBehaviorIndicatorAssignmentDisplayProvider : public QObject {
public:
	typedef typename DataModel::Behavior_Indicator_Column_t type_t;
public:
	DataModelBehaviorIndicatorAssignmentDisplayProvider(boost::shared_ptr<DataModel> dataModel, QObject *parent)
		:QObject(parent), dataModel(dataModel) {}
	virtual ~DataModelBehaviorIndicatorAssignmentDisplayProvider(){}

	const typename DataModel::Behavior_Indicator_Column_Container_t &getAssignments() {
		return dataModel->getBehaviorIndicatorColumns();
	}

	boost::shared_ptr<DataModel> getDataModel() {
		return dataModel;
	}

private:
	boost::shared_ptr<DataModel> dataModel;
};


} /* namespace gui */


#endif /* DATAMODELBEHAVIORINDICATORASSIGNMENTDISPLAYPROVIDER_HPP_ */
