/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * EnhancedQTextEdit.hpp
 *
 *  Created on: Jul 28, 2014
 *      Author: gerberma
 */

#ifndef ENHANCEDQTEXTEDITWIDGET_HPP_
#define ENHANCEDQTEXTEDITWIDGET_HPP_

#include <QWidget>
#include <QTextEdit>
#include <QObject>

namespace gui {

class EnhancedQTextEdit : public QTextEdit {
public:
	Q_OBJECT;
public:
	EnhancedQTextEdit(QWidget *parent = 0)
		:QTextEdit(parent)
	{
		connectLocal();
	}

	QString text() {
		return QTextEdit::toPlainText();
	}

	void setText(QString text) {
		QTextEdit::setPlainText(text);
	}

signals:
	void editingFinished();

public slots:
	void editingFinishedSlot() {
		emit editingFinished();
	}
private:
	void connectLocal() {
		connect(this, SIGNAL(textChanged()), this, SLOT(editingFinishedSlot()));
	}
};

}  // namespace gui


#endif /* ENHANCEDQTEXTEDITWIDGET_HPP_ */
