/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * FileDialog.cpp
 *
 *  Created on: Nov 22, 2013
 *      Author: gerberma
 */

#include <QUrl>
#include <QFileDialog>
#include "FileDialog.hpp"

namespace gui {

FileDialog::FileDialog() {
}

FileDialog::~FileDialog() {
}

QString FileDialog::getSaveFileName(QString forType) {
	QString caption = tr("Save %1").arg(forType);
	QString filetype = tr("DamBASE %1 (*.xml)").arg(forType);


	return QFileDialog::getSaveFileName(0, caption, "", filetype);
}

QString gui::FileDialog::getOpenFileName(QString forType) {
	QString caption = tr("Open %1").arg(forType);
	QString filetype = tr("DamBASE %1 (*.xml)").arg(forType);


	return QFileDialog::getOpenFileName(0, caption, "", filetype);
}

QString gui::FileDialog::getOpenFileName(QString forType, QString forFileType) {
	QString caption = tr("Open %1").arg(forType);
	QString filetype = tr("DamBASE %1 (*.%2)").arg(forType).arg(forFileType);

	return QFileDialog::getOpenFileName(0, caption, "", filetype);
}


QUrl FileDialog::getOpenUrl(QString forType, QString forFileType) {
	return QUrl(getOpenFileName(forType, forFileType));
}

} /* namespace gui */

