/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * GroupBoxLayout.cpp
 *
 *  Created on: Jan 7, 2014
 *      Author: gerberma
 */

#include <QGroupBox>
#include "gui/GroupBoxLayoutBuilder.hpp"

namespace gui {

GroupBoxLayoutBuilder::GroupBoxLayoutBuilder(const QString name)
	:name(name)
{
	gridLayout = new QGridLayout;
}

GroupBoxLayoutBuilder::~GroupBoxLayoutBuilder() {
	// TODO Auto-generated destructor stub
}

void GroupBoxLayoutBuilder::addWidget(QWidget* w) {
	gridLayout->addWidget(w);
}

void GroupBoxLayoutBuilder::addWidget(QWidget* w, int row, int column, Qt::Alignment alignment) {
	gridLayout->addWidget(w, row, column, alignment);
}

void GroupBoxLayoutBuilder::addWidget(QWidget* w, int row, int column, int rowSpan, int columnSpan, Qt::Alignment alignment) {
	gridLayout->addWidget(w, row, column, rowSpan, columnSpan, alignment);
}

QVBoxLayout* GroupBoxLayoutBuilder::build(QWidget *parent, QSizePolicy groupBoxSizePolicy, bool useSpacer) {
	QVBoxLayout *mainLayout = new QVBoxLayout;
	QGroupBox *dataModelGroupBox = new QGroupBox(name, parent);
	dataModelGroupBox->setLayout(gridLayout);
	dataModelGroupBox->setSizePolicy(groupBoxSizePolicy);

	mainLayout->addWidget(dataModelGroupBox);

	if(useSpacer) {
		QSpacerItem *spacer = new QSpacerItem(1,1,QSizePolicy::Ignored, QSizePolicy::Expanding);
		mainLayout->addSpacerItem(spacer);
	}

	return mainLayout;
}

} /* namespace gui */
