/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * GroupBoxLayoutBuilder.hpp
 *
 *  Created on: Jan 7, 2014
 *      Author: gerberma
 */

#ifndef GROUPBOXLAYOUTBUILDER_HPP_
#define GROUPBOXLAYOUTBUILDER_HPP_

#include <QGridLayout>
#include <QString>


namespace gui {

class GroupBoxLayoutBuilder{
public:
	GroupBoxLayoutBuilder(const QString name);
	virtual ~GroupBoxLayoutBuilder();

public:
    void addWidget(QWidget *w);
    void addWidget(QWidget *, int row, int column, Qt::Alignment = 0);
    void addWidget(QWidget *, int row, int column, int rowSpan, int columnSpan, Qt::Alignment = 0);

    QVBoxLayout *build(QWidget *parent, QSizePolicy groupBoxSizePolicy = QSizePolicy(QSizePolicy::Expanding, QSizePolicy::Fixed), bool useSpacer = true);
private:
    QGridLayout *gridLayout;
    const QString name;
};

} /* namespace gui */

#endif /* GROUPBOXLAYOUTBUILDER_HPP_ */
