/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * AddButton.hpp
 *
 *  Created on: Jan 21, 2014
 *      Author: gerberma
 */

#ifndef ADDBUTTON_HPP_
#define ADDBUTTON_HPP_

#include <QPushButton>

namespace gui {

class MoveToolbarButton : public QPushButton {
public:
	MoveToolbarButton(QString const &description, QWidget *parent = 0);
	virtual ~MoveToolbarButton();

private:
	void setupLayout();
};


inline gui::MoveToolbarButton::MoveToolbarButton(QString const &description, QWidget *parent)
	:QPushButton(description, parent)
{
	QSizePolicy s(QSizePolicy::Maximum, QSizePolicy::Maximum);
	setSizePolicy(s);
/*
	int textWidth = fontMetrics().boundingRect(text()).width();
	setMaximumWidth(textWidth+15);
*/
	setFixedWidth(25);
	setFixedHeight(25);
}

inline gui::MoveToolbarButton::~MoveToolbarButton() {
}

inline void gui::MoveToolbarButton::setupLayout() {
}

} /* namespace gui */

#endif /* ADDBUTTON_HPP_ */
