/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * OverviewEditButton.hpp
 *
 *  Created on: Jan 14, 2014
 *      Author: gerberma
 */

#ifndef OVERVIEWEDITBUTTON_HPP_
#define OVERVIEWEDITBUTTON_HPP_

#include <QString>
#include <QSizePolicy>
#include <QPushButton>

namespace gui {

class OverviewEditButton : public QPushButton {
public:
	OverviewEditButton(QWidget *parent = 0);
	OverviewEditButton(QString name, QWidget *parent);

private:
	void init();
};

inline OverviewEditButton::OverviewEditButton(QWidget *parent)
	:QPushButton(parent)
{
	setText(tr("edit"));
	init();
}

inline OverviewEditButton::OverviewEditButton(QString name, QWidget *parent)
	:QPushButton(name, parent)
{
	init();
}

inline void OverviewEditButton::init() {
	QPushButton::setSizePolicy(QSizePolicy::Maximum, QSizePolicy::Fixed);
}

} /* namespace gui */

#endif /* OVERVIEWEDITBUTTON_HPP_ */
