/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * OverviewKeyValueGridLayout.hpp
 *
 *  Created on: Jan 14, 2014
 *      Author: gerberma
 */

#ifndef OVERVIEWKEYVALUEGRIDLAYOUT_HPP_
#define OVERVIEWKEYVALUEGRIDLAYOUT_HPP_

#include <QGridLayout>

namespace gui {

class OverviewKeyValueGridLayout : public QGridLayout {
public:
	OverviewKeyValueGridLayout();
	virtual ~OverviewKeyValueGridLayout();

	template<typename KeyValueLabel>
	void addKeyValueLabels(KeyValueLabel *keyValueLabel, int lineIndex);

	template<typename EditButton>
	void setEditButton(EditButton *editButton, int lineIndex);
};


inline gui::OverviewKeyValueGridLayout::OverviewKeyValueGridLayout() {
}

inline gui::OverviewKeyValueGridLayout::~OverviewKeyValueGridLayout() {
}

template<typename KeyValueLabel>
inline void gui::OverviewKeyValueGridLayout::addKeyValueLabels(KeyValueLabel* keyValueLabel, int lineIndex) {
	addWidget(keyValueLabel->getKeyLabel(), lineIndex, 0, Qt::AlignTop);
	addWidget(keyValueLabel->getValueLabel(), lineIndex, 1, Qt::AlignTop);
}

template<typename EditButton>
inline void gui::OverviewKeyValueGridLayout::setEditButton(EditButton* editButton, int lineIndex) {
	addWidget(editButton, lineIndex, 2, Qt::AlignRight | Qt::AlignTop);
}


} /* namespace gui */

#endif /* OVERVIEWKEYVALUEGRIDLAYOUT_HPP_ */
