/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * RegressionModelExecuteRegressionWidget.hpp
 *
 *  Created on: Apr 10, 2014
 *      Author: gerberma
 */

#ifndef REGRESSIONMODELEXECUTEREGRESSIONWIDGET_HPP_
#define REGRESSIONMODELEXECUTEREGRESSIONWIDGET_HPP_

#include <QWidget>
#include <QHBoxLayout>
#include <boost/shared_ptr.hpp>
#include "GenericPushButton.hpp"

namespace gui {

template<typename RegressionModel>
class RegressionModelExecuteRegressionWidget : public QWidget
{
public:
	COM_SUBSCRIPTION_DELEGATE_FUNCTION(GenericPushButton<RegressionModel>, executeButton, Clicked);
public:
	RegressionModelExecuteRegressionWidget(boost::shared_ptr<RegressionModel> regressionModel, QWidget *parent = 0)
		:QWidget(parent), regressionModel(regressionModel)
	{
		setupLayout();
	}

	virtual ~RegressionModelExecuteRegressionWidget(){;}

private:
	void setupLayout() {
		QHBoxLayout *mainLayout = new QHBoxLayout(this);
		executeButton = new GenericPushButton<RegressionModel>(regressionModel, this);
		executeButton->setText(tr("Execute Regression"));
		mainLayout->addWidget(executeButton, 1, Qt::AlignLeft);

		setLayout(mainLayout);
	}

private:
	GenericPushButton<RegressionModel> *executeButton;
	boost::shared_ptr<RegressionModel> regressionModel;
};

}  // namespace gui



#endif /* REGRESSIONMODELEXECUTEREGRESSIONWIDGET_HPP_ */
