/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * SVGPlotDisplayWidget.hpp
 *
 *  Created on: Apr 1, 2014
 *      Author: gerberma
 */

#ifndef SVGPLOTDISPLAYWIDGET_HPP_
#define SVGPLOTDISPLAYWIDGET_HPP_

#include <QWidget>
#include "SvgPlotWidget.hpp"

namespace gui {

template<typename T>
class SVGPlotDisplayWidget : public QWidget {
public:
	typedef T type_t;
public:
	SVGPlotDisplayWidget(QString name, T *normalProbability, QWidget *parent = 0)
		:QWidget(parent), name(name), t(normalProbability)
	{
		setupLayout();
	}

	QString getName() {
		return name;
	}

	T *get() {
		return t;
	}

	void setupLayout() {
		QVBoxLayout *mainLayout = new QVBoxLayout;
			svgPlotWidget = new SvgPlotWidget<T>(t, this);
			mainLayout->addWidget(svgPlotWidget, Qt::AlignCenter);
		setLayout(mainLayout);
	}

	void updateValues() {
		//not necessary here but implemented due to be api conform
	}

private:
	QString name;
	T *t;
	SvgPlotWidget<T> *svgPlotWidget;
};

}  // namespace gui


#endif /* SVGPLOTDISPLAYWIDGET_HPP_ */
