/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * SaveDialog.hpp
 *
 *  Created on: Jul 24, 2014
 *      Author: gerberma
 */

#ifndef SAVEDIALOG_HPP_
#define SAVEDIALOG_HPP_

#include <QFileDialog>

namespace gui {

template<typename T> //Note that we use T only to distinguish between different cases which allows setting up different factories for different cases
class SaveDialog
{
public:
	SaveDialog(QString title, QString fileFilter)
		:title(title), fileFilter(fileFilter)
	{;}

	QString getSaveLocation() {
	    return QFileDialog::getSaveFileName(0, title, "", fileFilter);
	}

private:
	QString title;
	QString fileFilter;
};


}  // namespace gui


#endif /* SAVEDIALOG_HPP_ */
