/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * SplittedLayoutBuilder.cpp
 *
 *  Created on: Jan 7, 2014
 *      Author: gerberma
 */

#include "SplittedLayoutBuilder.hpp"
#include <QSplitter>

namespace gui {


SplittedLayoutBuilder::SplittedLayoutBuilder() {
}

SplittedLayoutBuilder::~SplittedLayoutBuilder() {
}

QVBoxLayout* SplittedLayoutBuilder::build(QWidget* parentWidget, QWidget* widget0, QWidget* widget1) {
	QSplitter *splitter = new QSplitter(Qt::Horizontal, parentWidget);

	if(widget0 != NULL) {
		splitter->addWidget(widget0);
	}

	if(widget1 != NULL) {
		splitter->addWidget(widget1);
	}

	splitter->setStretchFactor(0, 1);
	splitter->setStretchFactor(1, 1);

	QVBoxLayout *layout = new QVBoxLayout(parentWidget);
	layout->addWidget(splitter);


	return layout;
}

} /* namespace gui */
