/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * WizardNextIdStrategy.hpp
 *
 *  Created on: Jan 8, 2014
 *      Author: gerberma
 */

#ifndef WIZARDNEXTIDSTRATEGY_HPP_
#define WIZARDNEXTIDSTRATEGY_HPP_

#include <map>

namespace gui {

template<typename T>
class WizardNextIdStrategy : public QObject {
public:
	typedef T type_t;
public:
	WizardNextIdStrategy(T fallback = (T)-1, QObject *parent = 0):QObject(parent), fallback(fallback){}
	virtual ~WizardNextIdStrategy(){}

	void setTransition(T from, T to) {
		transitions[from] = to;
	}

	T nextFrom(T from) {
		if(transitions.find(from) == transitions.end()) {
			return fallback;
		}
		return transitions[from];
	}

private:
	T fallback;
	std::map<T, T> transitions;
};

} /* namespace gui */


#endif /* WIZARDNEXTIDSTRATEGY_HPP_ */
