/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * WizardPage.hpp
 *
 *  Created on: Jan 10, 2014
 *      Author: gerberma
 */

#ifndef WIZARDPAGE_HPP_
#define WIZARDPAGE_HPP_

#include <QWizardPage>

namespace gui {

template
<
	typename NextIdStrategy
>
class WizardPage : public QWizardPage
{
public:
	WizardPage(QWidget *parent, NextIdStrategy *nextIdStrategy, typename NextIdStrategy::type_t myId);
	virtual ~WizardPage();

	int nextId() const;

protected:
	NextIdStrategy *nextIdStrategy;
	typename NextIdStrategy::type_t myId;
};

template<typename NextIdStrategy>
inline gui::WizardPage<NextIdStrategy>::WizardPage(
		QWidget* parent,
		NextIdStrategy* nextIdStrategy,
		typename NextIdStrategy::type_t myId)
	:QWizardPage(parent), nextIdStrategy(nextIdStrategy), myId(myId)
{
}

template<typename NextIdStrategy>
inline gui::WizardPage<NextIdStrategy>::~WizardPage() {
}

template<typename NextIdStrategy>
inline int gui::WizardPage<NextIdStrategy>::nextId() const {
	return nextIdStrategy->nextFrom(myId);
}


} /* namespace gui */

#endif /* WIZARDPAGE_HPP_ */
