/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * AlgorithmReportListElement.hpp
 *
 *  Created on: 25.02.2015
 *      Author: gerberma
 */

#ifndef ALGORITHMREPORTLISTELEMENT_HPP_
#define ALGORITHMREPORTLISTELEMENT_HPP_

#include <QString>
#include <boost/shared_ptr.hpp>
#include "api/IRegressionModel.hpp"
#include "api/IAlgorithmReportListElement.hpp"

namespace dambase {
namespace model {

class AlgorithmReportListElement : public api::IAlgorithmReportListElement {
public:
	AlgorithmReportListElement(boost::shared_ptr<api::IRegressionModel> regressionModel, int index);
	virtual ~AlgorithmReportListElement();

	QString getName();

	int getIndex();

	void build(api::IAlgorithmReportListElement::ReportContext_t &reportContext);

	bool isSelected();

	void setIsSelected(bool state);

private:
	int index;
	bool isselected;
	boost::shared_ptr<api::IRegressionModel> regressionModel;
};

} /* namespace model */
} /* namespace dambase */
#endif /* ALGORITHMREPORTLISTELEMENT_HPP_ */
