/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * AnalysisActionRules.hpp
 *
 *  Created on: Dec 12, 2013
 *      Author: gerberma
 */

#ifndef ANALYSISACTIONRULES_HPP_
#define ANALYSISACTIONRULES_HPP_

namespace dambase {
namespace model {

class AnalysisActionRules {
public:
	AnalysisActionRules();
	virtual ~AnalysisActionRules();

	template<typename Analysis>
	bool isNewDataModelAllowedFor(Analysis *analysis);

	template<typename Analysis>
	bool isNewRegressionModelAllowedFor(Analysis *analysis);
};

inline model::AnalysisActionRules::AnalysisActionRules() {
}

inline model::AnalysisActionRules::~AnalysisActionRules() {
}


template<
	typename Analysis
>
inline bool AnalysisActionRules::isNewDataModelAllowedFor(Analysis* analysis) {
	return analysis->getDataModel() == NULL;
}


template<
	typename Analysis
>
inline bool AnalysisActionRules::isNewRegressionModelAllowedFor(Analysis* analysis) {
	return analysis->getDataModel() != NULL && analysis->getDataModel()->getBehaviorIndicatorColumns().size() != 0;
}


}} /* namespace dambase::model */

#endif /* ANALYSISACTIONRULES_HPP_ */
