/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * AnalysisToolModeDescription.hpp
 *
 *  Created on: 14.10.2014
 *      Author: gerberma
 */

#ifndef ANALYSISTOOLMODEDESCRIPTION_HPP_
#define ANALYSISTOOLMODEDESCRIPTION_HPP_

#include <boost/shared_ptr.hpp>
#include "api/IAnalysisToolModeDescription.hpp"

namespace dambase {
namespace model {

class AnalysisToolModeDescription : public virtual api::IAnalysisToolModeDescription {
public:
	AnalysisToolModeDescription(boost::shared_ptr<api::IAnalysisToolModeDescription::AnalysisToolDescription_t> analysisToolDescription);

	AnalysisToolModeDescription(
			boost::shared_ptr<api::IAnalysisToolModeDescription::AnalysisToolDescription_t> analysisToolDescription,
			bool appearLeft,
			bool appearEverywhere,
			int tabNumber,
			bool appearAutomatically,
			int appearForMode
	);

	virtual ~AnalysisToolModeDescription();

	/**
	 * Together with setAppearAutomatically, this flag defines on which side the AT should appear automatically if AppearAutomatically is set to true
	 */
	void setAppearLeft(bool flag);

	bool appearLeft(bool question);

	void setAppearEverywhere(bool flag);

	bool appearEverywhere(bool question);

	void setForTabNumber(int number);

	bool forTabNumber(int question);

	void setAppearAutomatically(bool flag);

	bool appearAutomatically(bool question);

	void setForMode(int mode);

	bool forMode(boost::shared_ptr<api::IAnalysisToolModeDescription::ModeHandler_t> question);

	boost::shared_ptr<api::IAnalysisToolModeDescription::AnalysisToolDescription_t> getAnalysisToolDescription();

private:
	boost::shared_ptr<api::IAnalysisToolModeDescription::AnalysisToolDescription_t> analysisToolDescription;
	bool flagAppearLeft;
	bool flagAppearEverywhere;
	int tabNumber;
	bool flagAppearAutomatically;
	int appearForMode;
};

}  // namespace model
}  // namespace dambase


#endif /* ANALYSISTOOLMODEDESCRIPTION_HPP_ */
