/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * AnalysisToolReportListElement.cpp
 *
 *  Created on: 17.02.2015
 *      Author: gerberma
 */


#include "AnalysisToolReportListElement.hpp"

namespace dambase {
namespace model {

AnalysisToolReportListElement::AnalysisToolReportListElement(boost::shared_ptr<api::IAnalysisToolReportListElement::AnalysisTool_t> analysisTool, int index)
	: analysisTool(analysisTool), index(index), isselected(true)
{;}

QString
AnalysisToolReportListElement::getName() {
	return analysisTool->getName();
}

int
AnalysisToolReportListElement::getIndex() {
	return index;
}

bool
AnalysisToolReportListElement::isSelected() {
	return isselected;
}

void
AnalysisToolReportListElement::setIsSelected(bool state) {
	isselected = state;
}

void
AnalysisToolReportListElement::build(api::IAnalysisToolReportListElement::ReportContext_t &reportContext) {
	//os << "## AnalysisToolReportListElement" << endl;
	reportContext << "## " << analysisTool->getName() << endl; //TODO: use a ReportPolicy and call build(this, reportContext) on it
	analysisTool->build(reportContext);
	//TODO: delegate to project which adds information about itself to the stream
}

} //namespace model
} //namespace dambase

