/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * AnalysisToolReportListElement.hpp
 *
 *  Created on: Jul 21, 2014
 *      Author: gerberma
 */

#ifndef ANALYSISTOOLREPORTLISTELEMENT_HPP_
#define ANALYSISTOOLREPORTLISTELEMENT_HPP_

#include "api/IAnalysisToolReportListElement.hpp"

namespace dambase {
namespace model {

class AnalysisToolReportListElement : public api::IAnalysisToolReportListElement {
public:
	AnalysisToolReportListElement(boost::shared_ptr<api::IAnalysisToolReportListElement::AnalysisTool_t> analysisTool, int index);

	QString getName();

	int getIndex();

	bool isSelected();

	void setIsSelected(bool state);

	void build(api::IAnalysisToolReportListElement::ReportContext_t &reportContext);

private:
	boost::shared_ptr<api::IAnalysisToolReportListElement::AnalysisTool_t> analysisTool;
	int index;
	bool isselected;
};


}  // namespace model
}  // namespace dambase




#endif /* ANALYSISTOOLREPORTLISTELEMENT_HPP_ */
