/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * AnalysisToolsDescriptions.hpp
 *
 *  Created on: Jan 22, 2014
 *      Author: gerberma
 */

#ifndef ANALYSISTOOLSDESCRIPTIONS_HPP_
#define ANALYSISTOOLSDESCRIPTIONS_HPP_

#include <boost/shared_ptr.hpp>
#include <vector>
#include "api/IAnalysisToolsDescriptions.hpp"

namespace dambase {
namespace model {

/**
 * Holds type related analysis tool descriptions such as for data model analysis and so on
 */
class AnalysisToolsDescriptions : public api::IAnalysisToolsDescriptions {
public:
	AnalysisToolsDescriptions(
			boost::shared_ptr<api::IAnalysisToolsDescriptions::dataModel_analysis_tools_description_t> dataModelAnalysisToolsDescription,
			boost::shared_ptr<api::IAnalysisToolsDescriptions::regressionModel_analysis_tools_description_t> regressionModelAnalysisToolsDesription);

	virtual ~AnalysisToolsDescriptions();

	boost::shared_ptr<api::IAnalysisToolsDescriptions::dataModel_analysis_tools_description_t> getDataModelAnalysisToolsDescription();

	boost::shared_ptr<api::IAnalysisToolsDescriptions::regressionModel_analysis_tools_description_t> getRegressionModelAnalysisToolsDescription();

private:
	boost::shared_ptr<api::IAnalysisToolsDescriptions::dataModel_analysis_tools_description_t> dataModelAnalysisToolsDescription;
	boost::shared_ptr<api::IAnalysisToolsDescriptions::regressionModel_analysis_tools_description_t> regressionModelAnalysisToolsDesription;
};

}} /* namespace dambase::model */

#endif /* ANALYSISTOOLSDESCRIPTIONS_HPP_ */
