/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * AnalysisToolsModeDescription.hpp
 *
 *  Created on: 14.10.2014
 *      Author: gerberma
 */

#ifndef ANALYSISTOOLSMODEDESCRIPTION_HPP_
#define ANALYSISTOOLSMODEDESCRIPTION_HPP_

#include <vector>
#include "api/IAnalysisToolsModeDescription.hpp"

namespace dambase {
namespace model {

class AnalysisToolsModeDescription : public virtual api::IAnalysisToolsModeDescription {
public:
	AnalysisToolsModeDescription(boost::shared_ptr<api::IAnalysisToolsModeDescription::ModeHandler_t> modeHandler);

	void addAnalysisToolModeDescription(boost::shared_ptr<api::IAnalysisToolsModeDescription::AnalysisToolModeDescription_t> analysisToolModeDescription);

	std::vector<boost::shared_ptr<api::IAnalysisToolsModeDescription::AnalysisToolDescription_t> > filterForAutomaticallyAppear(bool left, int tabNumber, bool automatically);

	std::vector<boost::shared_ptr<api::IAnalysisToolsModeDescription::AnalysisToolDescription_t> > filterForListingEverywhere();

	std::vector<boost::shared_ptr<api::IAnalysisToolsModeDescription::AnalysisToolDescription_t> > filterForListing(int tabNumber);

	std::vector<boost::shared_ptr<api::IAnalysisToolsModeDescription::AnalysisToolDescription_t> > filterForListing(bool left, int tabNumber);

private:
	boost::shared_ptr<api::IAnalysisToolsModeDescription::ModeHandler_t> modeHandler;
	std::vector<boost::shared_ptr<api::IAnalysisToolsModeDescription::AnalysisToolModeDescription_t> > analysisToolsModeDescriptions;
};

}  // namespace model
}  // namespace dambase


#endif /* ANALYSISTOOLSMODEDESCRIPTION_HPP_ */
