/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * AssignmentCategory.hpp
 *
 *  Created on: Aug 12, 2014
 *      Author: gerberma
 */

#ifndef ASSIGNMENTCATEGORY_HPP_
#define ASSIGNMENTCATEGORY_HPP_

#include <QString>
#include "r/api/IAssignmentCategory.hpp"

namespace model {

class AssignmentCategory : public virtual ::dambase::model::r::api::IAssignmentCategory {
public:
	AssignmentCategory(QString identifier, QString name, int index, bool hascolumns = true) : hascolumns(hascolumns), identifier(identifier), name(name), index(index)
	{;}

	const QString &getIdentifier() const {
		return identifier;
	}

	QString getName() {
		return name;
	}

	bool hasColumns() {
		return hascolumns;
	}

	int getIndex() {
		return index;
	}

private:
	bool hascolumns;
	QString identifier;
	QString name;
	int index;
};

}  // namespace model


#endif /* ASSIGNMENTCATEGORY_HPP_ */
