/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * DataModelAnalysisSettings.hpp
 *
 *  Created on: 01.10.2014
 *      Author: gerberma
 */

#ifndef DATAMODELANALYSISSETTINGS_HPP_
#define DATAMODELANALYSISSETTINGS_HPP_

#include <vector>
#include <boost/shared_ptr.hpp>
#include "api/IDataModelAnalysisSettings.hpp"

namespace dambase {
namespace model {

class DataModelAnalysisSettings : public virtual api::IDataModelAnalysisSettings {
public:
	DataModelAnalysisSettings();
	virtual ~DataModelAnalysisSettings();

	void addAutomaticLeftSideOverviewCategoryAnalysisToolDescription(boost::shared_ptr<api::IDataModelAnalysisSettings::AnalysisToolDescription_t> analysisToolDescription);

	std::vector<boost::shared_ptr<api::IDataModelAnalysisSettings::AnalysisToolDescription_t> > &getAutomaticLeftSideOverviewCategoryAnalysisToolDescriptions();

	void addAutomaticRightSideOverviewCategoryAnalysisToolDescription(boost::shared_ptr<api::IDataModelAnalysisSettings::AnalysisToolDescription_t> analysisToolDescription);

	std::vector<boost::shared_ptr<api::IDataModelAnalysisSettings::AnalysisToolDescription_t> > &getAutomaticRightSideOverviewCategoryAnalysisToolDescriptions();
private:
	std::vector<boost::shared_ptr<api::IDataModelAnalysisSettings::AnalysisToolDescription_t> > automaticLeftSideOverviewCategoryAnalysisToolDescriptions;
	std::vector<boost::shared_ptr<api::IDataModelAnalysisSettings::AnalysisToolDescription_t> > automaticRightSideOverviewCategoryAnalysisToolDescriptions;
};

}  // namespace model
}  // namespace dambase


#endif /* DATAMODELANALYSISSETTINGS_HPP_ */
