/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * DataModelAnalysisToolsDescription.hpp
 *
 *  Created on: Jan 22, 2014
 *      Author: gerberma
 */

#ifndef DATAMODELANALYSISTOOLSDESCRIPTION_HPP_
#define DATAMODELANALYSISTOOLSDESCRIPTION_HPP_

#include <boost/shared_ptr.hpp>
#include <vector>
#include "api/IDataModelAnalysisToolsDescription.hpp"

namespace dambase {
namespace model {

class DataModelAnalysisToolsDescription : public virtual api::IDataModelAnalysisToolsDescription
{
public:
	DataModelAnalysisToolsDescription(std::vector<boost::shared_ptr<api::IDataModelAnalysisToolsDescription::tool_description_t> > &overviewToolsDescription, std::vector<boost::shared_ptr<api::IDataModelAnalysisToolsDescription::tool_description_t> > &distributionToolsDescription, boost::shared_ptr<api::IDataModelAnalysisToolsDescription::ModeHandler_t> modeHandler);
	virtual ~DataModelAnalysisToolsDescription();

	std::vector<boost::shared_ptr<api::IDataModelAnalysisToolsDescription::tool_description_t> > &getOverviewAnalysisToolsDescription();

	std::vector<boost::shared_ptr<api::IDataModelAnalysisToolsDescription::tool_description_t> > &getDistributionAnalysisToolsDescription();

	boost::shared_ptr<api::IDataModelAnalysisToolsDescription::tool_description_t> findOverviewAnalysisToolDescriptionById(QString id);

	boost::shared_ptr<api::IDataModelAnalysisToolsDescription::ModeHandler_t> getModeHandler();
private:
	boost::shared_ptr<api::IDataModelAnalysisToolsDescription::tool_description_t> findById(QString id, std::vector<boost::shared_ptr<api::IDataModelAnalysisToolsDescription::tool_description_t> > &descriptions);

private:
	std::vector<boost::shared_ptr<api::IDataModelAnalysisToolsDescription::tool_description_t> > overviewToolsDescription;
	std::vector<boost::shared_ptr<api::IDataModelAnalysisToolsDescription::tool_description_t> > distributionToolsDescription;
	boost::shared_ptr<api::IDataModelAnalysisToolsDescription::ModeHandler_t> modeHandler;
};

}} /* namespace dambase::model */



#endif /* DATAMODELANALYSISTOOLSDESCRIPTION_HPP_ */
