/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * DescriptionReportListElement.cpp
 *
 *  Created on: 17.02.2015
 *      Author: gerberma
 */



#include "DescriptionReportListElement.hpp"

namespace dambase {
namespace model {

DescriptionReportListElement::DescriptionReportListElement(QString text, int index) : text(text), index(index), isselected(true){;}

QString
DescriptionReportListElement::getText() {
	return text;
}

void
DescriptionReportListElement::setText(QString text) {
	this->text = text;
}

QString
DescriptionReportListElement::getName() {
	return "Description";
}

int
DescriptionReportListElement::getIndex() {
	return index;
}

void
DescriptionReportListElement::build(api::IDescriptionReportListElement::ReportContext_t &reportContext) {
	reportContext << "## Description" << endl;
	reportContext << reportContext.escape(text) << endl << endl;
}

bool
DescriptionReportListElement::isSelected() {
	return isselected;
}

void
DescriptionReportListElement::setIsSelected(bool state) {
	isselected = state;
}

} //namespace model
} //namespace dambase
