/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * ModeHandler.hpp
 *
 *  Created on: 14.10.2014
 *      Author: gerberma
 */

#ifndef MODEHANDLER_HPP_
#define MODEHANDLER_HPP_

#include "api/IModeHandler.hpp"

namespace dambase {
namespace model {

class ModeHandler : public api::IModeHandler {
public:
	ModeHandler(int defaultMode = 1);
	void setMode(int mode);
	int getMode();
	bool isScientific();

private:
	int mode;
};


}  // namespace model
}  // namespace dambase


#endif /* MODEHANDLER_HPP_ */
