/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * ModeSettings.cpp
 *
 *  Created on: 16.02.2015
 *      Author: gerberma
 */

#include "ModeSettings.hpp"

namespace dambase {
namespace model {

ModeSettings::ModeSettings(boost::shared_ptr<api::IModeSettings::ModeHandler_t> modeHandler,
		boost::shared_ptr<api::IModeSettings::AnalysisToolsModeDescription_t> regressionModelAnalysisToolsModeDescription,
		boost::shared_ptr<api::IModeSettings::AnalysisToolsModeDescription_t> dataModelAnalysisToolsModeDescription)
	:modeHandler(modeHandler),
	 regressionModelAnalysisToolsModeDescription(regressionModelAnalysisToolsModeDescription),
	 dataModelAnalysisToolsModeDescription(dataModelAnalysisToolsModeDescription)
{
}

boost::shared_ptr<api::IModeSettings::AnalysisToolsModeDescription_t>
ModeSettings::getRegressionModelAnalysisToolsModeDescription() {
	return regressionModelAnalysisToolsModeDescription;
}

boost::shared_ptr<api::IModeSettings::AnalysisToolsModeDescription_t>
ModeSettings::getDataModelAnalysisToolsModeDescription() {
	return dataModelAnalysisToolsModeDescription;
}

boost::shared_ptr<api::IModeSettings::ModeHandler_t>
ModeSettings::getModeHandler() {
	return modeHandler;
}

} //namespace model
} //namespace dambase
