/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * ModeSettings.hpp
 *
 *  Created on: 14.10.2014
 *      Author: gerberma
 */

#ifndef MODESETTINGS_HPP_
#define MODESETTINGS_HPP_

#include "api/IModeSettings.hpp"

namespace dambase {
namespace model {

class ModeSettings : public virtual api::IModeSettings {
public:
	ModeSettings(boost::shared_ptr<api::IModeSettings::ModeHandler_t> modeHandler,
			boost::shared_ptr<api::IModeSettings::AnalysisToolsModeDescription_t> regressionModelAnalysisToolsModeDescription,
			boost::shared_ptr<api::IModeSettings::AnalysisToolsModeDescription_t> dataModelAnalysisToolsModeDescription);

	boost::shared_ptr<api::IModeSettings::AnalysisToolsModeDescription_t> getRegressionModelAnalysisToolsModeDescription();

	boost::shared_ptr<api::IModeSettings::AnalysisToolsModeDescription_t> getDataModelAnalysisToolsModeDescription();

	boost::shared_ptr<api::IModeSettings::ModeHandler_t> getModeHandler();

private:
	boost::shared_ptr<api::IModeSettings::ModeHandler_t> modeHandler;
	boost::shared_ptr<api::IModeSettings::AnalysisToolsModeDescription_t> regressionModelAnalysisToolsModeDescription;
	boost::shared_ptr<api::IModeSettings::AnalysisToolsModeDescription_t> dataModelAnalysisToolsModeDescription;
};

}  // namespace model
}  // namespace dambase


#endif /* MODESETTINGS_HPP_ */
