/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * ProjectReportListElement.cpp
 *
 *  Created on: 17.02.2015
 *      Author: gerberma
 */


#include "ProjectReportListElement.hpp"

namespace dambase {
namespace model {

ProjectReportListElement::ProjectReportListElement(boost::shared_ptr<api::IProjectReportListElement::Project_t> project, boost::shared_ptr<api::IProjectReportListElement::Analysis_t> analysis, boost::shared_ptr<api::IProjectReportListElement::RegressionModel_t> regressionModel, int index)
	: project(project), analysis(analysis), regressionModel(regressionModel), index(index), isselected(true) {;}

QString
ProjectReportListElement::getName() {
	return "Project";
}

int
ProjectReportListElement::getIndex() {
	return index;
}

void
ProjectReportListElement::build(api::IProjectReportListElement::ReportContext_t &reportContext) {
	reportContext << "## Project (" << project->getName() << ")" << endl << endl;
	reportContext << "### Description" << endl << endl;
	reportContext << reportContext.escape(project->getDescription()) << endl << endl;
	reportContext << "### Dam operator" << endl << endl;
	reportContext << reportContext.escape(project->getDamOperator()) << endl << endl;

	//TODO: delegate to project which adds information about itself to the stream
}

bool
ProjectReportListElement::isSelected() {
	return isselected;
}

void
ProjectReportListElement::setIsSelected(bool state) {
	isselected = state;
}

} //namespace model
} //namespace dambase

