/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * ProjectReportListElement.hpp
 *
 *  Created on: Jul 21, 2014
 *      Author: gerberma
 */

#ifndef PROJECTREPORTLISTELEMENT_HPP_
#define PROJECTREPORTLISTELEMENT_HPP_

#include <QString>
#include "api/IProjectReportListElement.hpp"

namespace dambase {
namespace model {

class ProjectReportListElement : public api::IProjectReportListElement {
public:
	ProjectReportListElement(boost::shared_ptr<api::IProjectReportListElement::Project_t> project, boost::shared_ptr<api::IProjectReportListElement::Analysis_t> analysis, boost::shared_ptr<api::IProjectReportListElement::RegressionModel_t> regressionModel, int index);

	QString getName();

	int getIndex();

	void build(api::IProjectReportListElement::ReportContext_t &reportContext);

	bool isSelected();

	void setIsSelected(bool state);

private:
	boost::shared_ptr<api::IProjectReportListElement::Project_t> project;
	boost::shared_ptr<api::IProjectReportListElement::Analysis_t> analysis;
	boost::shared_ptr<api::IProjectReportListElement::RegressionModel_t> regressionModel;
	int index;
	bool isselected;
};


}  // namespace model
}  // namespace dambase


#endif /* PROJECTREPORTLISTELEMENT_HPP_ */
