/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * RawDataCollectionPolicies.hpp
 *
 *  Created on: 07.10.2014
 *      Author: gerberma
 */

#ifndef RAWDATACOLLECTIONPOLICIES_HPP_
#define RAWDATACOLLECTIONPOLICIES_HPP_

#include <boost/shared_ptr.hpp>

namespace dambase {
namespace model {

class ExternalRawDataCollectionPolicy {
public:
	template<typename T, typename RawPlotDataCollector>
	void build(boost::shared_ptr<T> t, boost::shared_ptr<RawPlotDataCollector> rc);

	bool supportRawDataExport() {
		return true;
	}
};

class DisabledRawDataCollectionPolicy {
public:
	template<typename T, typename RawPlotDataCollector>
	void build(boost::shared_ptr<T> t, boost::shared_ptr<RawPlotDataCollector> rc){;} //do nothing

	bool supportRawDataExport() {
		return false;
	}
};

}  // namespace model
}  // namespace dambase


#endif /* RAWDATACOLLECTIONPOLICIES_HPP_ */
