/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * RegressionModelAnalysisToolsDescription.hpp
 *
 *  Created on: Mar 7, 2014
 *      Author: gerberma
 */

#ifndef REGRESSIONMODELANALYSISTOOLSDESCRIPTION_HPP_
#define REGRESSIONMODELANALYSISTOOLSDESCRIPTION_HPP_

#include "api/IRegressionModelAnalysisToolsDescription.hpp"

namespace dambase {
namespace model {

class RegressionModelAnalysisToolsDescription : public virtual api::IRegressionModelAnalysisToolsDescription
{
public:
	RegressionModelAnalysisToolsDescription(
			boost::shared_ptr<api::IRegressionModelAnalysisToolsDescription::AnalysisToolsModeDescription_t> analysisToolsModeDescription,
			boost::shared_ptr<api::IRegressionModelAnalysisToolsDescription::ModeHandler_t> modeHandler
	);

	virtual ~RegressionModelAnalysisToolsDescription();

	api::IRegressionModelAnalysisToolsDescription::container_t getPhysicsAnalysisToolsDescription();

	api::IRegressionModelAnalysisToolsDescription::container_t getStatisticsAnalysisToolsDescription();

	boost::shared_ptr<api::IRegressionModelAnalysisToolsDescription::tool_description_t> findStatisticsAnalysisToolDescriptionById(QString id);

	boost::shared_ptr<api::IRegressionModelAnalysisToolsDescription::tool_description_t> findPhysicsAnalysisToolDescriptionById(QString id);

	//left side
	api::IRegressionModelAnalysisToolsDescription::container_t getAutomaticLeftSidePhysicalCategoryAnalysisToolDescriptions();

	api::IRegressionModelAnalysisToolsDescription::container_t getAutomaticLeftSideStatisticsCategoryAnalysisToolDescriptions();

	//right side
	api::IRegressionModelAnalysisToolsDescription::container_t getAutomaticRightSidePhysicalCategoryAnalysisToolDescriptions();

	api::IRegressionModelAnalysisToolsDescription::container_t getAutomaticRightSideStatisticsCategoryAnalysisToolDescriptions();

	boost::shared_ptr<api::IRegressionModelAnalysisToolsDescription::ModeHandler_t> getModeHandler();

private:
	boost::shared_ptr<api::IRegressionModelAnalysisToolsDescription::tool_description_t> findAnalysisToolDescriptionById(std::vector<boost::shared_ptr<tool_description_t> > container, QString id);

private:
	boost::shared_ptr<api::IRegressionModelAnalysisToolsDescription::AnalysisToolsModeDescription_t>analysisToolsModeDescription;
	boost::shared_ptr<api::IRegressionModelAnalysisToolsDescription::ModeHandler_t> modeHandler;
};

}} /* namespace dambase::model */


#endif /* REGRESSIONMODELANALYSISTOOLSDESCRIPTION_HPP_ */
