/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * ReportPolicies.hpp
 *
 *  Created on: Jul 22, 2014
 *      Author: gerberma
 */

#ifndef REPORTPOLICIES_HPP_
#define REPORTPOLICIES_HPP_

#include <boost/shared_ptr.hpp>

namespace dambase {
namespace model {

class ExternalReportPolicy {
public:
	template<typename T, typename ReportContext>
	void build(boost::shared_ptr<T> t, ReportContext &rc);

	/**
	 * Note, this could also be handled with boost mpl and a typedef flag with true_ or false_
	 */
	bool supportsReporting() {
		return true;
	}
};

class DisabledReportPolicy {
public:
	template<typename T, typename ReportContext>
	void build(boost::shared_ptr<T> t, ReportContext &rc){;}

	/**
	 * Note, this could also be handled with boost mpl and a typedef flag with true_ or false_
	 */
	bool supportsReporting() {
		return false;
	}
};

} // namespace model
} // namespace dambase


#endif /* REPORTPOLICIES_HPP_ */
