/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * SignalPolicies.hpp
 *
 *  Created on: Nov 21, 2013
 *      Author: gerberma
 */

#ifndef SIGNALPOLICIES_HPP_
#define SIGNALPOLICIES_HPP_

#include "communication/Signals.hpp"

namespace communication {

class BoostSignalPolicy {
public:
	//typedef boost::signals2::signal<void()> changed_signal_t;
	typedef communication::SimpleChangedSignal::signal_t changed_signal_t;
	typedef communication::SimpleChangedSignal::subscriber_t changed_signal_subscriber_t;
	typedef typename communication::Signals::connection_t connection_t;


	/**
	 * Wrapper for subscribe
	 */
	connection_t subscribeForChanges(const changed_signal_subscriber_t &subscriber) {
		return subscribe(subscriber);
	}

	connection_t subscribeForChanged(const changed_signal_subscriber_t &subscriber) {
			return subscribe(subscriber);
	}

	connection_t subscribe(const changed_signal_subscriber_t &subscriber) {
		return changedSignal.connect(subscriber);
	}

	void fire() {
		changedSignal();
	}

private:
	changed_signal_t changedSignal;
};


} /* namespace communication */

#endif /* SIGNALPOLICIES_HPP_ */
