/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * TitleReportListElement.hpp
 *
 *  Created on: Jul 17, 2014
 *      Author: gerberma
 */

#ifndef TITLEREPORTLISTELEMENT_HPP_
#define TITLEREPORTLISTELEMENT_HPP_

#include <QString>
#include "api/ITitleReportListElement.hpp"

namespace dambase {
namespace model {

class TitleReportListElement : public api::ITitleReportListElement {
public:
	TitleReportListElement(QString text, QString referenceText, int index);

	QString getText();

	void setText(QString title);

	QString getName();

	int getIndex();

	void build(api::ITitleReportListElement::ReportContext_t &reportContext);

	bool isSelected();

	void setIsSelected(bool state);

private:
	QString text;
	QString referenceText;
	int index;
	bool isselected;
};


}  // namespace model
}  // namespace dambase


#endif /* TITLEREPORTLISTELEMENT_HPP_ */
