/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * WaterLevelScalingMinMaxOpLevel.cpp
 *
 *  Created on: 17.02.2015
 *      Author: gerberma
 */

#include "WaterLevelScalingMinMaxOpLevel.hpp"

namespace dambase {
namespace model {

WaterLevelScalingMinMaxOpLevel::WaterLevelScalingMinMaxOpLevel()
	:minimumOperatingLevel(0.0), fullSupplyLevel(0.0), isenabled(false)
{;}

WaterLevelScalingMinMaxOpLevel::~WaterLevelScalingMinMaxOpLevel(){;}

const double &
WaterLevelScalingMinMaxOpLevel::getFullSupplyLevel() const {
	return fullSupplyLevel;
}

void
WaterLevelScalingMinMaxOpLevel::setFullSupplyLevel(double fullSupplyLevel) {
	this->fullSupplyLevel = fullSupplyLevel;
	api::IWaterLevelScalingMinMaxOpLevel::fire();
}

const double &
WaterLevelScalingMinMaxOpLevel::getMinimumOperatingLevel() const {
	return minimumOperatingLevel;
}

void
WaterLevelScalingMinMaxOpLevel::setMinimumOperatingLevel(double minimumOperatingLevel) {
	this->minimumOperatingLevel = minimumOperatingLevel;
	api::IWaterLevelScalingMinMaxOpLevel::fire();
}

const bool &
WaterLevelScalingMinMaxOpLevel::isEnabled() const {
	return isenabled;
}

void
WaterLevelScalingMinMaxOpLevel::setIsEnabled(bool isEnabled) {
	this->isenabled = isEnabled;
	api::IWaterLevelScalingMinMaxOpLevel::fire();
}

} //namespace model
} //namespace dambase


