/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * WaterLevelScalingMinMaxOpLevel.hpp
 *
 *  Created on: 12.11.2014
 *      Author: gerberma
 */

#ifndef WATERLEVELSCALINGMINMAXOPLEVEL_HPP_
#define WATERLEVELSCALINGMINMAXOPLEVEL_HPP_

#include "api/IWaterLevelScalingMinMaxOpLevel.hpp"

namespace dambase {
namespace model {

class WaterLevelScalingMinMaxOpLevel : public api::IWaterLevelScalingMinMaxOpLevel {
public:
	WaterLevelScalingMinMaxOpLevel();

	virtual ~WaterLevelScalingMinMaxOpLevel();

	const double &getFullSupplyLevel() const;

	void setFullSupplyLevel(double fullSupplyLevel);

	const double &getMinimumOperatingLevel() const;

	void setMinimumOperatingLevel(double minimumOperatingLevel);

	const bool &isEnabled() const;

	void setIsEnabled(bool isEnabled);

private:
	double minimumOperatingLevel;
	double fullSupplyLevel;
	bool isenabled;
};

}}  // namespace dambase::model


#endif /* WATERLEVELSCALINGMINMAXOPLEVEL_HPP_ */
