/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * GenericAnalysisToolSignalPolicy.hpp
 *
 *  Created on: Mar 28, 2014
 *      Author: gerberma
 */

#ifndef GENERICANALYSISTOOLSIGNALPOLICY_HPP_
#define GENERICANALYSISTOOLSIGNALPOLICY_HPP_

#include "model/SignalPolicies.hpp"

namespace dambase {
namespace model {
namespace api {

class GenericAnalysisToolSignalPolicy : public communication::BoostSignalPolicy {
public:
	GenericAnalysisToolSignalPolicy(){;}
	virtual ~GenericAnalysisToolSignalPolicy(){;}

	COM_SUBSCRIPTION_FUNCTION(Loaded, communication::Signal<void()>);

	void fireLoaded() {
		fire();
		LoadedSignal();
	}

	void fire() {
		communication::BoostSignalPolicy::fire();
	}
};

}  // namespace api
}  // namespace model
}  // namespace dambase


#endif /* GENERICANALYSISTOOLSIGNALPOLICY_HPP_ */
