/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * IAnalysisToolModeDescription.hpp
 *
 *  Created on: 16.02.2015
 *      Author: gerberma
 */

#ifndef IANALYSISTOOLMODEDESCRIPTION_HPP_
#define IANALYSISTOOLMODEDESCRIPTION_HPP_

#include <boost/shared_ptr.hpp>
#include "IAnalysisToolDescription.hpp"
#include "IModeHandler.hpp"

namespace dambase {
namespace model {
namespace api {

class IAnalysisToolModeDescription {
public:
	typedef IAnalysisToolDescription AnalysisToolDescription_t;
	typedef IModeHandler ModeHandler_t;
public:
	IAnalysisToolModeDescription(){;}
	virtual ~IAnalysisToolModeDescription(){;}

	/**
	 * Together with setAppearAutomatically, this flag defines on which side the AT should appear automatically if AppearAutomatically is set to true
	 */
	virtual void setAppearLeft(bool flag) = 0;

	virtual bool appearLeft(bool question) = 0;

	virtual void setAppearEverywhere(bool flag) = 0;

	virtual bool appearEverywhere(bool question) = 0;

	virtual void setForTabNumber(int number) = 0;

	virtual bool forTabNumber(int question) = 0;

	virtual void setAppearAutomatically(bool flag) = 0;

	virtual bool appearAutomatically(bool question) = 0;

	virtual void setForMode(int mode) = 0;

	virtual bool forMode(boost::shared_ptr<ModeHandler_t> question) = 0;

	virtual boost::shared_ptr<AnalysisToolDescription_t> getAnalysisToolDescription() = 0;
};

} //namespace api
} //namespace model
} //namespace dambase


#endif /* IANALYSISTOOLMODEDESCRIPTION_HPP_ */
