/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * IAnalysisToolReportListElement.hpp
 *
 *  Created on: 17.02.2015
 *      Author: gerberma
 */

#ifndef IANALYSISTOOLREPORTLISTELEMENT_HPP_
#define IANALYSISTOOLREPORTLISTELEMENT_HPP_

#include <QString>
#include <boost/shared_ptr.hpp>
#include "IAnalysisTool.hpp"
#include "IReportListElement.hpp"

namespace dambase {
namespace model {
namespace api {

class IAnalysisToolReportListElement : public IReportListElement {
public:
	typedef IAnalysisTool AnalysisTool_t;
public:
	IAnalysisToolReportListElement(){;}
	virtual ~IAnalysisToolReportListElement(){;}

	virtual QString getName() = 0;

	virtual int getIndex() = 0;

	virtual bool isSelected() = 0;

	virtual void setIsSelected(bool state) = 0;

	virtual void build(IReportListElement::ReportContext_t &reportContext) = 0;
};

} //namespace api
} //namespace model
} //namespace dambase


#endif /* IANALYSISTOOLREPORTLISTELEMENT_HPP_ */
