/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * IAnalysisToolsDescriptions.hpp
 *
 *  Created on: 18.02.2015
 *      Author: gerberma
 */

#ifndef IANALYSISTOOLSDESCRIPTIONS_HPP_
#define IANALYSISTOOLSDESCRIPTIONS_HPP_

#include <boost/shared_ptr.hpp>
#include "IDataModelAnalysisToolsDescription.hpp"
#include "IRegressionModelAnalysisToolsDescription.hpp"

namespace dambase {
namespace model {
namespace api {

class IAnalysisToolsDescriptions {
public:
	typedef IDataModelAnalysisToolsDescription dataModel_analysis_tools_description_t;
	typedef IRegressionModelAnalysisToolsDescription regressionModel_analysis_tools_description_t;
public:
	IAnalysisToolsDescriptions(){;}
	virtual ~IAnalysisToolsDescriptions(){;}

	virtual boost::shared_ptr<dataModel_analysis_tools_description_t> getDataModelAnalysisToolsDescription() = 0;
	virtual boost::shared_ptr<regressionModel_analysis_tools_description_t> getRegressionModelAnalysisToolsDescription() = 0;
};

} //namespace api
} //namespace model
} //namespace

#endif /* IANALYSISTOOLSDESCRIPTIONS_HPP_ */
