/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * IAnalysisToolsModeDescription.hpp
 *
 *  Created on: 16.02.2015
 *      Author: gerberma
 */

#ifndef IANALYSISTOOLSMODEDESCRIPTION_HPP_
#define IANALYSISTOOLSMODEDESCRIPTION_HPP_

#include <vector>
#include <boost/shared_ptr.hpp>
#include "IAnalysisToolDescription.hpp"
#include "IAnalysisToolModeDescription.hpp"
#include "IModeHandler.hpp"

namespace dambase {
namespace model {
namespace api {

class IAnalysisToolsModeDescription {
public:
	typedef IAnalysisToolDescription AnalysisToolDescription_t;
	typedef IAnalysisToolModeDescription AnalysisToolModeDescription_t;
	typedef IModeHandler ModeHandler_t;
public:
	IAnalysisToolsModeDescription(){;}
	virtual ~IAnalysisToolsModeDescription(){;}

	virtual void addAnalysisToolModeDescription(boost::shared_ptr<AnalysisToolModeDescription_t> analysisToolModeDescription) = 0;

	virtual std::vector<boost::shared_ptr<AnalysisToolDescription_t> > filterForAutomaticallyAppear(bool left, int tabNumber, bool automatically) = 0;

	virtual std::vector<boost::shared_ptr<AnalysisToolDescription_t> > filterForListingEverywhere() = 0;

	virtual std::vector<boost::shared_ptr<AnalysisToolDescription_t> > filterForListing(int tabNumber) = 0;

	virtual std::vector<boost::shared_ptr<AnalysisToolDescription_t> > filterForListing(bool left, int tabNumber) = 0;
};

} //namespace api
} //namespace model
} //namespace

#endif /* IANALYSISTOOLSMODEDESCRIPTION_HPP_ */
