/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * IDataModelAnalysisSettings.hpp
 *
 *  Created on: 18.02.2015
 *      Author: gerberma
 */

#ifndef IDATAMODELANALYSISSETTINGS_HPP_
#define IDATAMODELANALYSISSETTINGS_HPP_

#include <boost/shared_ptr.hpp>
#include <vector>
#include "IAnalysisToolDescription.hpp"

namespace dambase {
namespace model {
namespace api {

class IDataModelAnalysisSettings {
public:
	typedef IAnalysisToolDescription AnalysisToolDescription_t;
public:
	IDataModelAnalysisSettings(){;}
	virtual ~IDataModelAnalysisSettings(){;}

	virtual void addAutomaticLeftSideOverviewCategoryAnalysisToolDescription(boost::shared_ptr<AnalysisToolDescription_t> analysisToolDescription) = 0;

	virtual std::vector<boost::shared_ptr<AnalysisToolDescription_t> > &getAutomaticLeftSideOverviewCategoryAnalysisToolDescriptions() = 0;

	virtual void addAutomaticRightSideOverviewCategoryAnalysisToolDescription(boost::shared_ptr<AnalysisToolDescription_t> analysisToolDescription) = 0;

	virtual std::vector<boost::shared_ptr<AnalysisToolDescription_t> > &getAutomaticRightSideOverviewCategoryAnalysisToolDescriptions() = 0;
};

} //namespace api
} //namespace model
} //namespace


#endif /* IDATAMODELANALYSISSETTINGS_HPP_ */
