/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * IDataModelAnalysisTimeSeriesOverview.hpp
 *
 *  Created on: 18.02.2015
 *      Author: gerberma
 */

#ifndef IDATAMODELANALYSISTIMESERIESOVERVIEW_HPP_
#define IDATAMODELANALYSISTIMESERIESOVERVIEW_HPP_

#include <boost/shared_ptr.hpp>
#include "IAnalysisTool.hpp"
#include "IDataModel.hpp"
#include "IDataModelAnalysisTimeSeriesOverview.hpp"
#include "r/api/IDataFrameTimeSeriesOverview.hpp"

namespace dambase {
namespace model {
namespace api {

class IDataModelAnalysisTimeSeriesOverview : public virtual IAnalysisTool {
public:
	typedef r::api::IDataFrameTimeSeriesOverview::DateContainer_t DateContainer_t;
	typedef r::api::IDataFrameTimeSeriesOverview::ValueContainer_t ValueContainer_t;
	typedef api::IDataModel DataModel_t;
	typedef DataModel_t::Column_t Column_t;
public:
	IDataModelAnalysisTimeSeriesOverview(){;}
	virtual ~IDataModelAnalysisTimeSeriesOverview(){;}

	virtual void setValueColumn(int index) = 0;

	virtual boost::shared_ptr<Column_t> getValueColumn() = 0;

	virtual QString getValueColumnName() = 0;

	virtual boost::shared_ptr<DataModel_t> getDataModel() = 0;

	virtual DateContainer_t &getDates() = 0;

	virtual ValueContainer_t &getValues() = 0;

	virtual void configurationUpdateRequested() = 0;

	virtual void execute() = 0;

	virtual bool supportsReporting() = 0;

	virtual bool supportRawDataExport() = 0;
};

} //namespace api
} //namespace model
} //namespace


#endif /* IDATAMODELANALYSISTIMESERIESOVERVIEW_HPP_ */
