/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * IDataModelAnalysisToolsDescription.hpp
 *
 *  Created on: 18.02.2015
 *      Author: gerberma
 */

#ifndef IDATAMODELANALYSISTOOLSDESCRIPTION_HPP_
#define IDATAMODELANALYSISTOOLSDESCRIPTION_HPP_

#include <QString>
#include <boost/shared_ptr.hpp>
#include <vector>
#include "IAnalysisToolDescription.hpp"
#include "IModeHandler.hpp"


namespace dambase {
namespace model {
namespace api {

class IDataModelAnalysisToolsDescription {
public:
	typedef IAnalysisToolDescription tool_description_t;
	typedef std::vector<boost::shared_ptr<tool_description_t> > container_t;
	typedef IModeHandler ModeHandler_t;
public:
	IDataModelAnalysisToolsDescription(){;}
	virtual ~IDataModelAnalysisToolsDescription(){;}

	virtual std::vector<boost::shared_ptr<tool_description_t> > &getOverviewAnalysisToolsDescription() = 0;

	virtual std::vector<boost::shared_ptr<tool_description_t> > &getDistributionAnalysisToolsDescription() = 0;

	virtual boost::shared_ptr<tool_description_t> findOverviewAnalysisToolDescriptionById(QString id) = 0;

	virtual boost::shared_ptr<ModeHandler_t> getModeHandler() = 0;
};

} //namespace api
} //namespace model
} //namespace


#endif /* IDATAMODELANALYSISTOOLSDESCRIPTION_HPP_ */
