/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * IDataModelOverviewStatistics.hpp
 *
 *  Created on: 18.02.2015
 *      Author: gerberma
 */

#ifndef IDATAMODELOVERVIEWSTATISTICS_HPP_
#define IDATAMODELOVERVIEWSTATISTICS_HPP_

#include "IAnalysisTool.hpp"

namespace dambase {
namespace model {
namespace api {

class IDataModelOverviewStatistics : public virtual IAnalysisTool {
public:
	IDataModelOverviewStatistics(){;}
	virtual ~IDataModelOverviewStatistics(){;}

	virtual int getTotalNumberOfDataPoints() = 0;

	virtual int getNumberOfNotAvailableDataPoints() = 0;

	// = getTotalNumberOfDataPoints() - getNumberOfNotAvailableDataPoints()
	virtual int getNumberOfAvailableDataPoints() = 0;

	virtual void configurationUpdateRequested() = 0;

	virtual void execute() = 0;

	virtual bool supportsReporting() = 0;

	virtual bool supportRawDataExport() = 0;
};

} //namespace api
} //namespace model
} //namespace

#endif /* IDATAMODELOVERVIEWSTATISTICS_HPP_ */
