/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * IModeHandler.hpp
 *
 *  Created on: 16.02.2015
 *      Author: gerberma
 */

#ifndef IMODEHANDLER_HPP_
#define IMODEHANDLER_HPP_

#include "model/SignalPolicies.hpp"
#include "communication/Signals.hpp"

namespace dambase {
namespace model {
namespace api {

class IModeHandler {
public:
	COM_SUBSCRIPTION_FUNCTION(ModeChanged, communication::Signal<void()>);
public:
	IModeHandler(){;}
	virtual ~IModeHandler(){;}

	virtual void setMode(int mode) = 0;

	virtual int getMode() = 0;

	virtual bool isScientific() = 0;
};

} //namespace api
} //namespace model
} //namespace


#endif /* IMODEHANDLER_HPP_ */
