/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * IProjectReportListElement.hpp
 *
 *  Created on: 17.02.2015
 *      Author: gerberma
 */

#ifndef IPROJECTREPORTLISTELEMENT_HPP_
#define IPROJECTREPORTLISTELEMENT_HPP_

#include "IProject.hpp"
#include "IAnalysis.hpp"
#include "IRegressionModel.hpp"
#include "IReportListElement.hpp"

namespace dambase {
namespace model {
namespace api {

class IProjectReportListElement : public IReportListElement  {
public:
	typedef IProject Project_t;
	typedef IAnalysis Analysis_t;
	typedef IRegressionModel RegressionModel_t;
public:
	IProjectReportListElement(){;}
	virtual ~IProjectReportListElement(){;}

	virtual QString getName() = 0;

	virtual int getIndex() = 0;

	virtual void build(IReportListElement::ReportContext_t &reportContext) = 0;

	virtual bool isSelected() = 0;

	virtual void setIsSelected(bool state) = 0;
};

} //namespace api
} //namespace model
} //namespace dambase


#endif /* IPROJECTREPORTLISTELEMENT_HPP_ */
