/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * IRegressionFitAnalysisRegressorTimeseries.hpp
 *
 *  Created on: 17.02.2015
 *      Author: gerberma
 */

#ifndef IREGRESSIONFITANALYSISREGRESSORTIMESERIES_HPP_
#define IREGRESSIONFITANALYSISREGRESSORTIMESERIES_HPP_

#include <boost/enable_shared_from_this.hpp>
#include "r/api/IAssignmentCategory.hpp"
#include "r/api/IRRegressionFitAnalysisRegressorTimeseries.hpp"
#include "IAnalysisTool.hpp"

namespace dambase {
namespace model {
namespace api {

class IRegressionFitAnalysisRegressorTimeseries : public IAnalysisTool, public boost::enable_shared_from_this<IRegressionFitAnalysisRegressorTimeseries> {
public:
	typedef r::api::IAssignmentCategory AssignmentCategory_t;
	typedef r::api::IRRegressionFitAnalysisRegressorTimeseries Item_t;
public:
	IRegressionFitAnalysisRegressorTimeseries(){;}
	virtual ~IRegressionFitAnalysisRegressorTimeseries(){;}

	virtual std::vector<boost::shared_ptr<api::IRegressionFitAnalysisRegressorTimeseries::Item_t> > getItems() = 0;

	virtual void setIsPolynom(bool ispolynom) = 0;

	virtual bool isPolynom() = 0;

	virtual void setIsScaled(bool isscaled) = 0;

	virtual bool isScaled() = 0;

	virtual void execute() = 0;

	virtual void build(api::IRegressionFitAnalysisRegressorTimeseries::ReportContext_t &rc) = 0;

	virtual void build(boost::shared_ptr<api::IRegressionFitAnalysisRegressorTimeseries::RawDataCollector_t> collector) = 0;

	virtual void setName(QString name) = 0;

	virtual QString getName() = 0;

	virtual void configurationUpdateRequested() = 0;

	virtual bool supportsReporting() = 0;

	virtual bool supportRawDataExport() = 0;
};

} //namespace api
} //namespace model
} //namespace


#endif /* IREGRESSIONFITANALYSISREGRESSORTIMESERIES_HPP_ */
