/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * IRegressionFitAnalysisResidualNormalProbability.hpp
 *
 *  Created on: 17.02.2015
 *      Author: gerberma
 */

#ifndef IREGRESSIONFITANALYSISRESIDUALNORMALPROBABILITY_HPP_
#define IREGRESSIONFITANALYSISRESIDUALNORMALPROBABILITY_HPP_

#include <boost/enable_shared_from_this.hpp>
#include <boost/shared_ptr.hpp>
#include <QString>
#include "IAnalysisTool.hpp"

namespace dambase {
namespace model {
namespace api {

class IRegressionFitAnalysisResidualNormalProbability : public IAnalysisTool, public boost::enable_shared_from_this<IRegressionFitAnalysisResidualNormalProbability> {
public:
	typedef r::api::IRRegressionFitAnalysisResidualNormalProbability::QuantileContainer_t QuantileContainer_t;
	typedef r::api::IRRegressionFitAnalysisResidualNormalProbability::Point_t Point_t;
public:
	IRegressionFitAnalysisResidualNormalProbability(){;}
	virtual ~IRegressionFitAnalysisResidualNormalProbability(){;}

	virtual QuantileContainer_t getTheoreticalQuantiles() = 0;

	virtual QuantileContainer_t getSampleQuantiles() = 0;

	virtual Point_t &getNormalLinePointOne() = 0;

	virtual Point_t &getNormalLinePointTwo() = 0;

	virtual void execute() = 0;

	virtual void build(ReportContext_t &rc) = 0;

	virtual void build(boost::shared_ptr<RawDataCollector_t> collector) = 0;

	virtual void setName(QString name) = 0;

	virtual QString getName() = 0;

	virtual void configurationUpdateRequested() = 0;

	virtual bool supportsReporting() = 0;

	virtual bool supportRawDataExport() = 0;
};

} //namespace api
} //namespace model
} //namespace

#endif /* IREGRESSIONFITANALYSISRESIDUALNORMALPROBABILITY_HPP_ */
