/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * IRegressionFitAnalysisResidualVersusRegressionParameter.hpp
 *
 *  Created on: 17.02.2015
 *      Author: gerberma
 */

#ifndef IREGRESSIONFITANALYSISRESIDUALVERSUSREGRESSIONPARAMETER_HPP_
#define IREGRESSIONFITANALYSISRESIDUALVERSUSREGRESSIONPARAMETER_HPP_

#include <boost/shared_ptr.hpp>
#include <boost/enable_shared_from_this.hpp>
#include "IAnalysisTool.hpp"
#include "r/api/IRRegressionFitAnalysisResidualVersusRegressionParameter.hpp"

namespace dambase {
namespace model {
namespace api {

class IRegressionFitAnalysisResidualVersusRegressionParameter : public IAnalysisTool, public boost::enable_shared_from_this<IRegressionFitAnalysisResidualVersusRegressionParameter> {
public:
	typedef r::api::IRRegressionFitAnalysisResidualVersusRegressionParameter::ResidualContainer_t ResidualContainer_t;
	typedef r::api::IRRegressionFitAnalysisResidualVersusRegressionParameter::ParameterValueContainer_t ParameterValueContainer_t;
public:
	IRegressionFitAnalysisResidualVersusRegressionParameter(){;}
	virtual ~IRegressionFitAnalysisResidualVersusRegressionParameter(){;}

	virtual ResidualContainer_t getResiduals() = 0;

	virtual ParameterValueContainer_t getParameterValues() = 0;

	virtual void execute() = 0;

	virtual void build(IAnalysisTool::ReportContext_t &rc) = 0;

	virtual void build(boost::shared_ptr<IAnalysisTool::RawDataCollector_t> collector) = 0;

	virtual void setName(QString name) = 0;

	virtual QString getName() = 0;

	virtual void configurationUpdateRequested() = 0;

	virtual bool supportsReporting() = 0;

	virtual bool supportRawDataExport() = 0;
};

} //namespace api
} //namespace model
} //namespace


#endif /* IREGRESSIONFITANALYSISRESIDUALVERSUSREGRESSIONPARAMETER_HPP_ */
