/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * IWaterLevelScalingMinMaxOpLevel.hpp
 *
 *  Created on: 17.02.2015
 *      Author: gerberma
 */

#ifndef IWATERLEVELSCALINGMINMAXOPLEVEL_HPP_
#define IWATERLEVELSCALINGMINMAXOPLEVEL_HPP_

#include "model/SignalPolicies.hpp"

namespace dambase {
namespace model {
namespace api {

class IWaterLevelScalingMinMaxOpLevel : public communication::BoostSignalPolicy {
public:
public:
	IWaterLevelScalingMinMaxOpLevel(){;}
	virtual ~IWaterLevelScalingMinMaxOpLevel(){;}

	virtual const double &getFullSupplyLevel() const = 0;

	virtual void setFullSupplyLevel(double fullSupplyLevel) = 0;

	virtual const double &getMinimumOperatingLevel() const = 0;

	virtual void setMinimumOperatingLevel(double minimumOperatingLevel) = 0;

	virtual const bool &isEnabled() const = 0;

	virtual void setIsEnabled(bool isEnabled) = 0;
};

} //namespace api
} //namespace model
} //namespace


#endif /* IWATERLEVELSCALINGMINMAXOPLEVEL_HPP_ */
