/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * DataFrameColumn.hpp
 *
 *  Created on: Dec 20, 2013
 *      Author: gerberma
 */

#ifndef DATAFRAMECOLUMN_HPP_
#define DATAFRAMECOLUMN_HPP_

#include "DataFrameHeader.hpp"

namespace dambase {
namespace model {
namespace r{


class DataFrameColumn {
public:
	typedef DataFrameHeader Header_t;
public:
	DataFrameColumn();
	DataFrameColumn(DataFrameHeader &dataFrameHeader);

	const DataFrameHeader &getHeader() const;
	void setHeader(const DataFrameHeader& dataFrameHeader);

	const QString &getName() const;

	const int &getIndex() const;
	//void setIndex(int index);

private:
	DataFrameHeader dataFrameHeader;
};


inline model::r::DataFrameColumn::DataFrameColumn()
{
}

inline model::r::DataFrameColumn::DataFrameColumn(DataFrameHeader &dataFrameHeader)
	:dataFrameHeader(dataFrameHeader)
{
}

inline const DataFrameHeader &model::r::DataFrameColumn::getHeader() const {
	return dataFrameHeader;
}

inline void model::r::DataFrameColumn::setHeader(const DataFrameHeader& dataFrameHeader) {
	this->dataFrameHeader = dataFrameHeader;
}

inline const QString &DataFrameColumn::getName() const{
	return dataFrameHeader.getName();
}

inline const int &DataFrameColumn::getIndex() const {
	return dataFrameHeader.getIndex();
}

/*
inline void DataFrameColumn::setIndex(int index) {
	this->index = index;
}
*/

}
}
} /* namespace dambase::model::r */


#endif /* DATAFRAMECOLUMN_HPP_ */
