/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * DataFrameHeader.hpp
 *
 *  Created on: Dec 20, 2013
 *      Author: gerberma
 */

#ifndef DATAFRAMEHEADER_HPP_
#define DATAFRAMEHEADER_HPP_

#include <QString>
#include <Rcpp.h>
#include <string>
#include <iostream>

namespace dambase {
namespace model {
namespace r {

class DataFrameHeader {
public:
	DataFrameHeader();
	DataFrameHeader(const Rcpp::String &name, int index);

	virtual ~DataFrameHeader();

	void setName(QString name) {
		this->name = name;
	}

	const QString &getName() const;

	void setIndex(int index) {
		this->index = index;
	}

	const int &getIndex() const;


private:
	QString name;
	int index;
};


inline DataFrameHeader::DataFrameHeader()
	:index(0)
{
}

inline model::r::DataFrameHeader::~DataFrameHeader() {
}

inline const QString &model::r::DataFrameHeader::getName() const {
	return name;
}

inline const int &model::r::DataFrameHeader::getIndex() const {
	return index;
}

inline DataFrameHeader::DataFrameHeader(const Rcpp::String &name, int index)
	:name(QString::fromStdString(name)), index(index)
{
}

}}} /* namespace dambase::model::r */

#endif /* DATAFRAMEHEADER_HPP_ */
