/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * DataFrameInfluenceFactors.cpp
 *
 *  Created on: 18.02.2015
 *      Author: gerberma
 */

#include <Rcpp.h>
#include "DataFrameInfluenceFactors.hpp"

namespace dambase {
namespace model {
namespace r {

DataFrameInfluenceFactors::DataFrameInfluenceFactors(Rcpp::List data){
	Rcpp::NumericVector rBehaviorIndicatorValues = Rcpp::as<Rcpp::NumericVector>(data["behaviorIndicatorColumnValues"]);
	BOOST_FOREACH(double value, rBehaviorIndicatorValues) {
		behaviorIndicatorColumnValues.push_back(value);
	}

	Rcpp::NumericVector rInfluenceFactorValues = Rcpp::as<Rcpp::NumericVector>(data["influenceFactorColumnValues"]);
	BOOST_FOREACH(double value, rInfluenceFactorValues) {
		influenceFactorColumnValues.push_back(value);
	}
}

DataFrameInfluenceFactors::~DataFrameInfluenceFactors(){;}

api::IDataFrameInfluenceFactors::ValueContainer_t
DataFrameInfluenceFactors::getBehaviorIndicatorColumnValues() {
	return behaviorIndicatorColumnValues;
}

api::IDataFrameInfluenceFactors::ValueContainer_t
DataFrameInfluenceFactors::getInfluenceFactorColumnValues() {
	return influenceFactorColumnValues;
}


} //namespace r
} //namespace model
} //namespace dambase
