/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * DataFrameInfluenceFactors.hpp
 *
 *  Created on: Jan 30, 2014
 *      Author: gerberma
 */

#ifndef DATAFRAMEINFLUENCEFACTORS_HPP_
#define DATAFRAMEINFLUENCEFACTORS_HPP_

#include <QString>
#include <Rcpp.h>
#include <vector>
#include <string>
#include <boost/foreach.hpp>
#include "api/IDataFrameInfluenceFactors.hpp"

namespace dambase {
namespace model {
namespace r {

class DataFrameInfluenceFactors : public virtual api::IDataFrameInfluenceFactors {
public:
	DataFrameInfluenceFactors(Rcpp::List data);

	virtual ~DataFrameInfluenceFactors();

	api::IDataFrameInfluenceFactors::ValueContainer_t getBehaviorIndicatorColumnValues();

	api::IDataFrameInfluenceFactors::ValueContainer_t getInfluenceFactorColumnValues();

private:
	api::IDataFrameInfluenceFactors::ValueContainer_t behaviorIndicatorColumnValues;
	api::IDataFrameInfluenceFactors::ValueContainer_t influenceFactorColumnValues;
};

}
}
} /* namespace dambase::model::r */

#endif /* DATAFRAMEINFLUENCEFACTORS_HPP_ */
