/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * DataFrameInfluenceFactorsProvider.hpp
 *
 *  Created on: Jan 30, 2014
 *      Author: gerberma
 */

#ifndef DATAFRAMEINFLUENCEFACTORSPROVIDER_HPP_
#define DATAFRAMEINFLUENCEFACTORSPROVIDER_HPP_

#include <boost/shared_ptr.hpp>
#include "DataFrameInfluenceFactors.hpp"
#include "api/IDataFrameInfluenceFactors.hpp"
#include "api/IDataFrameInfluenceFactorsProvider.hpp"

namespace dambase {
namespace model {
namespace r {

class DataFrameInfluenceFactorsProvider : public virtual api::IDataFrameInfluenceFactorsProvider {
public:
	DataFrameInfluenceFactorsProvider();
	virtual ~DataFrameInfluenceFactorsProvider();

	/**
	 * dataFrame as well as further information about what to plot
	 */
	boost::shared_ptr<api::IDataFrameInfluenceFactors> load(boost::shared_ptr<api::IDataFrameInfluenceFactorsProvider::DataFrame_t> dataFrame, boost::shared_ptr<api::IDataFrameInfluenceFactorsProvider::Column_t> behaviorIndicatorColumn, boost::shared_ptr<api::IDataFrameInfluenceFactorsProvider::Column_t> influenceFactorColumn);
};


}
}
} /* namespace dambase::model::r */


#endif /* DATAFRAMEINFLUENCEFACTORSPROVIDER_HPP_ */
