/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * DataFrameOverviewStatistics.cpp
 *
 *  Created on: 18.02.2015
 *      Author: gerberma
 */

#include "DataFrameOverviewStatistics.hpp"
#include <cmath>

namespace dambase {
namespace model {
namespace r {


DataFrameOverviewStatistics::DataFrameOverviewStatistics(Rcpp::List &statsList)
{
	if(statsList.containsElementNamed("totalNumberOfDataPoints") == false) {
		totalNumberOfDataPoints = nan(NULL);
	}

	totalNumberOfDataPoints = Rcpp::as<int>(statsList["totalNumberOfDataPoints"]);

	if(statsList.containsElementNamed("numberOfNotAvailableDataPoints") == false) {
		numberOfNotAvailableDataPoints = nan(NULL);
	}

	numberOfNotAvailableDataPoints = Rcpp::as<int>(statsList["numberOfNotAvailableDataPoints"]);

	if(statsList.containsElementNamed("numberOfAvailableDataPoints") == false) {
		numberOfAvailableDataPoints = nan(NULL);
	}

	numberOfAvailableDataPoints = Rcpp::as<int>(statsList["numberOfAvailableDataPoints"]);

}

DataFrameOverviewStatistics::~DataFrameOverviewStatistics() {
}

int
DataFrameOverviewStatistics::getTotalNumberOfDataPoints() {
	return totalNumberOfDataPoints;
}

int
DataFrameOverviewStatistics::getNumberOfNotAvailableDataPoints() {
	return numberOfNotAvailableDataPoints;
}

int
DataFrameOverviewStatistics::getNumberOfAvailableDataPoints() {
	return numberOfAvailableDataPoints;
}

} //namespace r
} //namespace model
} //namespace dambase
