/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * DataFrameOverviewStatistics.hpp
 *
 *  Created on: Jan 22, 2014
 *      Author: gerberma
 */

#ifndef DATAFRAMEOVERVIEWSTATISTICS_HPP_
#define DATAFRAMEOVERVIEWSTATISTICS_HPP_

#include <Rcpp.h>
#include "api/IDataFrameOverviewStatistics.hpp"

namespace dambase {
namespace model {
namespace r {

class DataFrameOverviewStatistics : public virtual api::IDataFrameOverviewStatistics {
public:
	DataFrameOverviewStatistics(Rcpp::List &statsList);
	virtual ~DataFrameOverviewStatistics();

	int getTotalNumberOfDataPoints();
	int getNumberOfNotAvailableDataPoints();
	int getNumberOfAvailableDataPoints();

private:
	int totalNumberOfDataPoints;
	int numberOfNotAvailableDataPoints;
	int numberOfAvailableDataPoints;
};

}
}
} /* namespace dambase::model::r */

#endif /* DATAFRAMEOVERVIEWSTATISTICS_HPP_ */
