/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * DataFrameOverviewStatisticsProvider.hpp
 *
 *  Created on: Jan 23, 2014
 *      Author: gerberma
 */

#ifndef DATAFRAMEOVERVIEWSTATISTICSPROVIDER_HPP_
#define DATAFRAMEOVERVIEWSTATISTICSPROVIDER_HPP_

#include <boost/shared_ptr.hpp>
#include "api/IDataFrameOverviewStatistics.hpp"
#include "api/IDataFrameOverviewStatisticsProvider.hpp"


namespace dambase {
namespace model {
namespace r {

class DataFrameOverviewStatisticsProvider : public virtual api::IDataFrameOverviewStatisticsProvider {
public:
	DataFrameOverviewStatisticsProvider();
	virtual ~DataFrameOverviewStatisticsProvider();

	boost::shared_ptr<api::IDataFrameOverviewStatistics> load(boost::shared_ptr<api::IDataFrame> dataFrame);
};

}
}
} /* namespace dambase::model::r */


#endif /* DATAFRAMEOVERVIEWSTATISTICSPROVIDER_HPP_ */
