/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * DataFrameProvider.hpp
 *
 *  Created on: Dec 18, 2013
 *      Author: gerberma
 */

#ifndef DATAFRAMEPROVIDER_HPP_
#define DATAFRAMEPROVIDER_HPP_

#include "api/IDataFrameProvider.hpp"

namespace dambase {
namespace model {
namespace r {

class DataFrameProvider : public virtual api::IDataFrameProvider {
public:
	DataFrameProvider();
	virtual ~DataFrameProvider();

	boost::shared_ptr<api::IDataFrameProvider::data_frame_type> load(QUrl uri, QString csvDelimiter = ",", unsigned missingDataStrategy = 0);

	void saveDataFrame(const Rcpp::DataFrame &dataFrame, QString location, boost::shared_ptr<api::IDataFrameProvider::DateColumn_t> dateColumn);

	Rcpp::DataFrame readDataFrame(QString location, boost::shared_ptr<api::IDataFrameProvider::DateColumn_t> dateColumn);

	Rcpp::DataFrame applyDateFormat(Rcpp::DataFrame &dataFrame, int dateColumnNr, QString dateFormat);

	bool testDateColumnValidity(Rcpp::DataFrame &dataFrame, int dateColumnNr);

	Rcpp::DataFrame applyMissingDataStrategy(Rcpp::DataFrame &dataFrame, unsigned missingDataStrategy);
};


}}} /* namespace dambase::model::r */


#endif /* DATAFRAMEPROVIDER_HPP_ */
