/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * DataFrameTimeSeriesOverview.cpp
 *
 *  Created on: 18.02.2015
 *      Author: gerberma
 */

#include <boost/foreach.hpp>
#include "DataFrameTimeSeriesOverview.hpp"

namespace dambase {
namespace model {
namespace r {

DataFrameTimeSeriesOverview::DataFrameTimeSeriesOverview(Rcpp::List data) {
	Rcpp::CharacterVector rDates = Rcpp::as<Rcpp::CharacterVector>(data["dateValues"]);
	BOOST_FOREACH(Rcpp::CharacterVector::value_type date, rDates) {
		dates.push_back(Rcpp::as<std::string>(date));
	}

	Rcpp::NumericVector rValues = Rcpp::as<Rcpp::NumericVector>(data["values"]);
	BOOST_FOREACH(double value, rValues) {
		values.push_back(value);
	}
}

DataFrameTimeSeriesOverview::~DataFrameTimeSeriesOverview(){;}

api::IDataFrameTimeSeriesOverview::DateContainer_t &
DataFrameTimeSeriesOverview::getDates() {
	return dates;
}

api::IDataFrameTimeSeriesOverview::ValueContainer_t &
DataFrameTimeSeriesOverview::getValues() {
	return values;
}

} //namespace r
} //namespace model
} //namespace dambase
