/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * DataFrameTimeSeriesOverviewProvider.cpp
 *
 *  Created on: 18.02.2015
 *      Author: gerberma
 */

#include <Rcpp.h>
#include "DataFrameTimeSeriesOverviewProvider.hpp"
#include "DataFrameTimeSeriesOverview.hpp"

namespace dambase {
namespace model {
namespace r {

DataFrameTimeSeriesOverviewProvider::DataFrameTimeSeriesOverviewProvider(){;}
DataFrameTimeSeriesOverviewProvider::~DataFrameTimeSeriesOverviewProvider(){;}

boost::shared_ptr<api::IDataFrameTimeSeriesOverview>
DataFrameTimeSeriesOverviewProvider::load(boost::shared_ptr<api::IDataFrameTimeSeriesOverviewProvider::DataFrame_t> dataFrame, boost::shared_ptr<api::IDataFrameTimeSeriesOverviewProvider::Column_t> valueColumn) {
	Rcpp::Environment damBaseEnv("package:DamBASE");
	Rcpp::Function loadDataFrameTimeSeriesOverview = damBaseEnv["loadDataFrameTimeSeriesOverview"];

	Rcpp::List data = loadDataFrameTimeSeriesOverview(
				Rcpp::Named("dataFrame", dataFrame->getDataFrame()),
				Rcpp::Named("dateColumnNr", dataFrame->getDateColumn()->getIndex() + 1), /* TODO: these is a fake indice */
				Rcpp::Named("valueColumnNr", valueColumn->getIndex() + 1) /* TODO: this is a fake indices */
			);

	boost::shared_ptr<api::IDataFrameTimeSeriesOverview> result(new DataFrameTimeSeriesOverview(data));
	return result;
}

} //namespace r
} //namespace model
} //namespace dambase
