/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * DataFrameTimeSeriesOverviewProvider.hpp
 *
 *  Created on: Mar 11, 2014
 *      Author: gerberma
 */

#ifndef DATAFRAMETIMESERIESOVERVIEWPROVIDER_HPP_
#define DATAFRAMETIMESERIESOVERVIEWPROVIDER_HPP_

#include <Rcpp.h>
#include <boost/filesystem.hpp>
#include <boost/shared_ptr.hpp>
#include <QFile>
#include <QTextStream>
#include <QRegExp>
#include "DataFrame.hpp"
#include "api/IDataFrameTimeSeriesOverview.hpp"
#include "api/IDataFrameTimeSeriesOverviewProvider.hpp"

namespace dambase {
namespace model {
namespace r {

class DataFrameTimeSeriesOverviewProvider : public api::IDataFrameTimeSeriesOverviewProvider {
public:
	DataFrameTimeSeriesOverviewProvider();
	virtual ~DataFrameTimeSeriesOverviewProvider();

	boost::shared_ptr<api::IDataFrameTimeSeriesOverview> load(boost::shared_ptr<api::IDataFrameTimeSeriesOverviewProvider::DataFrame_t> dataFrame, boost::shared_ptr<api::IDataFrameTimeSeriesOverviewProvider::Column_t> valueColumn);
};


}
}
} /* namespace dambase::model::r */


#endif /* DATAFRAMETIMESERIESOVERVIEWPROVIDER_HPP_ */
