/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * RManager.cpp
 *
 *  Created on: Dec 20, 2013
 *      Author: gerberma
 */

#include "RManager.hpp"
#include <iostream>

namespace dambase {
namespace model {
namespace r {

bool RManager::alreadyInitialized = false;


model::r::RManager::RManager(int argc, char* argv[])
{
	if(alreadyInitialized == false) {
		R = boost::shared_ptr<RInside>(new RInside(argc, argv));
		if(R == NULL) {
			std::cout << "R == NULL" << std::endl;
			return;
		}

		//please note to update testsuite.r loading list on changes made to this list
		R->parseEval("library(\"stats\")");
		R->parseEval("library(\"base\")");
		R->parseEval("library(\"utils\")");
		R->parseEval("library(\"lmtest\")"); //for dwstat
		R->parseEval("library(\"datasets\")");
		R->parseEval("library(\"methods\")");
		R->parseEval("library(\"grDevices\")");
		R->parseEval("library(\"graphics\")");
		R->parseEval("library(\"lubridate\")");
		R->parseEval("library(\"MASS\")");
		R->parseEval("library(\"DamBASE\")");

		alreadyInitialized = true;
	}
}

RManager::~RManager() {
}

}}} /* namespace dambase::model::r */
