/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * RRegressionFitAnalysisOverallRegressionQuality.hpp
 *
 *  Created on: Apr 15, 2014
 *      Author: gerberma
 */

#ifndef RREGRESSIONFITANALYSISOVERALLREGRESSIONQUALITY_HPP_
#define RREGRESSIONFITANALYSISOVERALLREGRESSIONQUALITY_HPP_

#include <Rcpp.h>
#include "api/IRRegressionFitAnalysisOverallRegressionQuality.hpp"

namespace dambase {
namespace model {
namespace r {

class RRegressionFitAnalysisOverallRegressionQuality : public virtual api::IRRegressionFitAnalysisOverallRegressionQuality {
public:
	RRegressionFitAnalysisOverallRegressionQuality(Rcpp::List values);
	~RRegressionFitAnalysisOverallRegressionQuality();

	double getAutocorDwStatDegree() const;
	double getAutocorDwStatValue() const;
	double getFitR2adjDegree() const;
	double getFitR2adjValue() const;

private:
	double autocorDwStatValue;
	double autocorDwStatDegree;
	double fitR2adjValue;
	double fitR2adjDegree;
};

} //namespace r
} //namespace model
} //namespace dambase

#endif /* RREGRESSIONFITANALYSISOVERALLREGRESSIONQUALITY_HPP_ */
