/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * RRegressionFitAnalysisPhysicalBehavior.hpp
 *
 *  Created on: 21.10.2014
 *      Author: gerberma
 */

#ifndef RREGRESSIONFITANALYSISPHYSICALBEHAVIOR_HPP_
#define RREGRESSIONFITANALYSISPHYSICALBEHAVIOR_HPP_

#include <stdexcept>
#include <vector>
#include <boost/foreach.hpp>
#include <Rcpp.h>
#include "api/IRRegressionFitAnalysisPhysicalBehavior.hpp"

namespace dambase {
namespace model {
namespace r {

class RRegressionFitAnalysisPhysicalBehavior : public virtual api::IRRegressionFitAnalysisPhysicalBehavior {
public:
	RRegressionFitAnalysisPhysicalBehavior(Rcpp::List values, QString name);
	~RRegressionFitAnalysisPhysicalBehavior();

	ApplyedValuesContainer_t &getApplyedValues();
	QString getResponseType();
	DateResponseContainer_t &getDateResponse();
	NumericResponseContainer_t getNumericResponse();
	QString getName();

private:
	ApplyedValuesContainer_t applyedValues;
	QString responseType;
	DateResponseContainer_t dateResponse;
	NumericResponseContainer_t numericResponse;
	QString name;
};

}  // namespace r
}  // namespace model
}  // namespace dambase


#endif /* RREGRESSIONFITANALYSISPHYSICALBEHAVIOR_HPP_ */
