/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * RRegressionFitAnalysisRegressionSummary.hpp
 *
 *  Created on: Mar 28, 2014
 *      Author: gerberma
 */

#ifndef RREGRESSIONFITANALYSISREGRESSIONSUMMARY_HPP_
#define RREGRESSIONFITANALYSISREGRESSIONSUMMARY_HPP_

#include <Rcpp.h>
#include <stdexcept>
#include "api/IRRegressionFitAnalysisRegressionSummary.hpp"

namespace dambase {
namespace model {
namespace r {

class RRegressionFitAnalysisRegressionSummary : public virtual api::IRRegressionFitAnalysisRegressionSummary {
public:
	RRegressionFitAnalysisRegressionSummary(Rcpp::List summary);
	~RRegressionFitAnalysisRegressionSummary();

	double getSSRes();
	double getMSRes();
	double getMSResDerived();
	double getR2();
	double getR2Adj();
	double getFStat();
	double getFStatPValue();
	double getDwStat();
	double getNobs();
	double getSSResPred();
	double getMSResDerivedPred();

private:
	double ssres;
	double msres;
	double msresderived;
	double r2;
	double r2adj;
	double fstat;
	double fstatpvalue;
	double dwstat;
	unsigned nobs;
	double ssresPred;
	double msresderivedPred;
};

}  // namespace r
}  // namespace model
}  // namespace dambase


#endif /* RREGRESSIONFITANALYSISREGRESSIONSUMMARY_HPP_ */
