/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * RRegressionFitAnalysisRegressorTimeseries.hpp
 *
 *  Created on: 28.10.2014
 *      Author: gerberma
 */

#ifndef RREGRESSIONFITANALYSISREGRESSORTIMESERIES_HPP_
#define RREGRESSIONFITANALYSISREGRESSORTIMESERIES_HPP_

#include <stdexcept>
#include <vector>
#include <boost/foreach.hpp>
#include <Rcpp.h>
#include <QString>
#include "api/IRRegressionFitAnalysisRegressorTimeseries.hpp"

namespace dambase {
namespace model {
namespace r {


class RRegressionFitAnalysisRegressorTimeseries : public virtual api::IRRegressionFitAnalysisRegressorTimeseries{
public:
	typedef std::vector<double> ApplyedValuesContainer_t;
	typedef std::string Date_t;
	typedef std::vector<Date_t> DateResponseContainer_t;
public:
	RRegressionFitAnalysisRegressorTimeseries(Rcpp::List values, QString name);
	virtual ~RRegressionFitAnalysisRegressorTimeseries();

	ApplyedValuesContainer_t &getApplyedValues();
	DateResponseContainer_t &getDateResponse();
	QString getName();

private:
	ApplyedValuesContainer_t applyedValues;
	DateResponseContainer_t dateResponse;
	QString name;
};

}  // namespace r
}  // namespace model
}  // namespace dambase

#endif /* RREGRESSIONFITANALYSISREGRESSORTIMESERIES_HPP_ */
