/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * RRegressionFitAnalysisResidualNormalProbability.hpp
 *
 *  Created on: Apr 1, 2014
 *      Author: gerberma
 */

#ifndef RREGRESSIONFITANALYSISRESIDUALNORMALPROBABILITY_HPP_
#define RREGRESSIONFITANALYSISRESIDUALNORMALPROBABILITY_HPP_

#include <Rcpp.h>
#include "Point.hpp"
#include "api/IRRegressionFitAnalysisResidualNormalProbability.hpp"

namespace dambase {
namespace model {
namespace r {

class RRegressionFitAnalysisResidualNormalProbability : public virtual api::IRRegressionFitAnalysisResidualNormalProbability {
public:
	RRegressionFitAnalysisResidualNormalProbability(Rcpp::List values);
	~RRegressionFitAnalysisResidualNormalProbability();

	QuantileContainer_t &getTheoreticalQuantiles();
	QuantileContainer_t &getSampleQuantiles();
	Point_t &getNormalLinePointOne();
	Point_t &getNormalLinePointTwo();

private:
	Rcpp::List values;
	Point_t normalPointOne;
	Point_t normalPointTwo;
	QuantileContainer_t theoreticalQuantiles;
	QuantileContainer_t sampleQuantiles;
};


}  // namespace r
}  // namespace model
}  // namespace dambase

#endif /* RREGRESSIONFITANALYSISRESIDUALNORMALPROBABILITY_HPP_ */
