/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * RRegressionFitAnalysisResidualVersusRegressionParameter.cpp
 *
 *  Created on: 09.02.2015
 *      Author: gerberma
 */


#include "RRegressionFitAnalysisResidualVersusRegressionParameter.hpp"

namespace dambase {
namespace model {
namespace r {

RRegressionFitAnalysisResidualVersusRegressionParameter::RRegressionFitAnalysisResidualVersusRegressionParameter(Rcpp::List values)
	:values(values)
{
	Rcpp::NumericVector rResiduals = Rcpp::as<Rcpp::NumericVector>(values["residuals"]);
	BOOST_FOREACH(double residual, rResiduals) {
		residuals.push_back(residual);
	}

	Rcpp::NumericVector rParameterValues = Rcpp::as<Rcpp::NumericVector>(values["parametervalues"]);
	BOOST_FOREACH(double parameterValue, rParameterValues) {
		parameterValues.push_back(parameterValue);
	}
}

RRegressionFitAnalysisResidualVersusRegressionParameter::~RRegressionFitAnalysisResidualVersusRegressionParameter(){;}

api::IRRegressionFitAnalysisResidualVersusRegressionParameter::ResidualContainer_t &
RRegressionFitAnalysisResidualVersusRegressionParameter::getResiduals() {
	return residuals;
}

api::IRRegressionFitAnalysisResidualVersusRegressionParameter::ParameterValueContainer_t &
RRegressionFitAnalysisResidualVersusRegressionParameter::getParameterValues() {
	return parameterValues;
}

} //namespace r
} //namespace model
} //namespace dambase

