/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * RRegressionFitAnalysisResidualVersusRegressionParameter.hpp
 *
 *  Created on: Apr 10, 2014
 *      Author: gerberma
 */

#ifndef RREGRESSIONFITRESIDUALVERSUSREGRESSIONPARAMETER_HPP_
#define RREGRESSIONFITRESIDUALVERSUSREGRESSIONPARAMETER_HPP_

#include <string>
#include <vector>
#include <boost/foreach.hpp>
#include <Rcpp.h>
#include "api/IRRegressionFitAnalysisResidualVersusRegressionParameter.hpp"

namespace dambase {
namespace model {
namespace r {

class RRegressionFitAnalysisResidualVersusRegressionParameter : public virtual api::IRRegressionFitAnalysisResidualVersusRegressionParameter {
public:
	RRegressionFitAnalysisResidualVersusRegressionParameter(Rcpp::List values);
	~RRegressionFitAnalysisResidualVersusRegressionParameter();

	ResidualContainer_t &getResiduals();
	ParameterValueContainer_t &getParameterValues();

private:
	Rcpp::List values;
	ResidualContainer_t residuals;
	ParameterValueContainer_t parameterValues;
};


}  // namespace r
}  // namespace model
}  // namespace dambase



#endif /* RREGRESSIONFITRESIDUALVERSUSREGRESSIONPARAMETER_HPP_ */
