/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * RegressionFit.hpp
 *
 *  Created on: Feb 19, 2014
 *      Author: gerberma
 */

#ifndef REGRESSIONFIT_HPP_
#define REGRESSIONFIT_HPP_

#include "api/IRegressionFit.hpp"

namespace dambase {
namespace model {
namespace r{

class RegressionFit : public virtual api::IRegressionFit {
public:
	RegressionFit(Rcpp::List wrappedFit, boost::shared_ptr<api::IRegressionFit::RegressionFormula_t> regressionFormula, boost::shared_ptr<api::IRegressionFit::RegressionFitDataFrame_t> regressionFitDataFrame);

	virtual ~RegressionFit();

	//double getCoefficientFor(boost::shared_ptr<api::IRegressor> regressor);

	double getIntercept();

	Rcpp::List getFit();

	boost::shared_ptr<api::IRegressionFit::RegressionFormula_t> getRegressionFormula();

	boost::shared_ptr<api::IRegressionFit::RegressionFitDataFrame_t> getRegressionFitDataFrame();

	int getOverallMaxStartupTime();

	double getPraisWinstenRho();

private:
	Rcpp::List wrappedFit;
	boost::shared_ptr<api::IRegressionFit::RegressionFormula_t> regressionFormula;
	boost::shared_ptr<api::IRegressionFit::RegressionFitDataFrame_t> regressionFitDataFrame;
	double praisWinstenRho;
};

}}} /* namespace dambase::model::r */

#endif /* REGRESSIONFIT_HPP_ */
