/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * RegressionFitAnalysisACFProvider.hpp
 *
 *  Created on: Apr 8, 2014
 *      Author: gerberma
 */

#ifndef REGRESSIONFITANALYSISACFPROVIDER_HPP_
#define REGRESSIONFITANALYSISACFPROVIDER_HPP_

#include <Rcpp.h>
#include <boost/shared_ptr.hpp>
#include "api/IRegressionFitAnalysisACFProvider.hpp"

namespace dambase {
namespace model {
namespace r {

class RegressionFitAnalysisACFProvider : public virtual api::IRegressionFitAnalysisACFProvider {
public:
	RegressionFitAnalysisACFProvider();
	virtual ~RegressionFitAnalysisACFProvider();

	boost::shared_ptr<api::IRRegressionFitAnalysisACF> load(boost::shared_ptr<api::IRegressionFit> regressionFit);
};

} //namespace r
} //namespace model
}  // namespace dambase

#endif /* REGRESSIONFITANALYSISACFPROVIDER_HPP_ */
