/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * RegressionFitAnalysisOverallRegressionQualityProvider.cpp
 *
 *  Created on: 16.02.2015
 *      Author: gerberma
 */

#include "RRegressionFitAnalysisOverallRegressionQuality.hpp"
#include "RegressionFitAnalysisOverallRegressionQualityProvider.hpp"

namespace dambase {
namespace model {
namespace r {

RegressionFitAnalysisOverallRegressionQualityProvider::RegressionFitAnalysisOverallRegressionQualityProvider(){;}
RegressionFitAnalysisOverallRegressionQualityProvider::~RegressionFitAnalysisOverallRegressionQualityProvider(){;}

boost::shared_ptr<api::IRRegressionFitAnalysisOverallRegressionQuality>
RegressionFitAnalysisOverallRegressionQualityProvider::load(boost::shared_ptr<api::IRegressionFit> regressionFit) {
		Rcpp::Environment damBaseEnv("package:DamBASE");
		Rcpp::Function function = damBaseEnv["loadOverallRegressionQuality"];

		Rcpp::List t = Rcpp::as<Rcpp::List>(function(
					Rcpp::Named("regressionFit", regressionFit->getFit())
				));

		boost::shared_ptr<api::IRRegressionFitAnalysisOverallRegressionQuality> result (new RRegressionFitAnalysisOverallRegressionQuality(t));
		return result;
	}

} //namespace r
} //namespace model
} //namespace dambase
