/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * RegressionFitAnalysisPhysicalBehaviorProvider.hpp
 *
 *  Created on: 21.10.2014
 *      Author: gerberma
 */

#ifndef REGRESSIONFITANALYSISPHYSICALBEHAVIORPROVIDER_HPP_
#define REGRESSIONFITANALYSISPHYSICALBEHAVIORPROVIDER_HPP_

#include "api/IRegressionFitAnalysisPhysicalBehaviorProvider.hpp"

namespace dambase {
namespace model {
namespace r {

class RegressionFitAnalysisPhysicalBehaviorProvider : public virtual api::IRegressionFitAnalysisPhysicalBehaviorProvider {
public:
	RegressionFitAnalysisPhysicalBehaviorProvider();
	virtual ~RegressionFitAnalysisPhysicalBehaviorProvider();

	/**
	 * Response must be a column of the dataFrame
	 */
	boost::shared_ptr<api::IRRegressionFitAnalysisPhysicalBehavior> load(boost::shared_ptr<api::IRegressionFit> regressionFit,
			Rcpp::Formula formula,
			Rcpp::DataFrame &dataFrame,
			boost::shared_ptr<api::IDataFrame::DateColumn_t> dateColumn,
			QString startDate,
			QString endDate,
			int overallMaxStartupTime,
			boost::shared_ptr<api::IDataFrame::Column_t> response,
			QString name,
			bool doApplyCoefficientsAndIntercept);
};

}  // namespace r
}  // namespace model
}  // namespace dambase


#endif /* REGRESSIONFITANALYSISPHYSICALBEHAVIORPROVIDER_HPP_ */
