/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * RegressionFitAnalysisPhysicalSummaryProvider.cpp
 *
 *  Created on: 16.02.2015
 *      Author: gerberma
 */

#include "RRegressionFitAnalysisPhysicalSummary.hpp"
#include "RegressionFitAnalysisPhysicalSummaryProvider.hpp"

namespace dambase {
namespace model {
namespace r {

RegressionFitAnalysisPhysicalSummaryProvider::RegressionFitAnalysisPhysicalSummaryProvider(){;}
RegressionFitAnalysisPhysicalSummaryProvider::~RegressionFitAnalysisPhysicalSummaryProvider(){;}

boost::shared_ptr<api::IRRegressionFitAnalysisPhysicalSummary>
RegressionFitAnalysisPhysicalSummaryProvider::load(boost::shared_ptr<api::IRegressionFit> regressionFit) {
		Rcpp::Environment damBaseEnv("package:DamBASE");
		Rcpp::Function loadRegressionFitAnalysisPhysicalSummary = damBaseEnv["loadRegressionFitAnalysisPhysicalSummary"];

		Rcpp::List values = Rcpp::as<Rcpp::List>(loadRegressionFitAnalysisPhysicalSummary(
					Rcpp::Named("regressionFit", regressionFit->getFit()),
					Rcpp::Named("dataFrame", regressionFit->getRegressionFormula()->getDataFrame()->getDataFrame()),
					Rcpp::Named("dateColumnNr", regressionFit->getRegressionFormula()->getDataFrame()->getDateColumn()->getIndex() + 1),
					Rcpp::Named("behaviorIndicatorColumnNr", regressionFit->getRegressionFormula()->getBehaviorIndicatorColumn()->getIndex() + 1),
					Rcpp::Named("startDate", regressionFit->getRegressionFitDataFrame()->getDateColumn()->getFirstValue().getDate().toStdString()),
					Rcpp::Named("regressionEndDate", regressionFit->getRegressionFitDataFrame()->getDateColumn()->getLastValue().getDate().toStdString()),
					Rcpp::Named("overallMaxStartupTime", regressionFit->getOverallMaxStartupTime())
				));

		boost::shared_ptr<api::IRRegressionFitAnalysisPhysicalSummary> result(new RRegressionFitAnalysisPhysicalSummary(values));

		return result;
	}

} //namespace r
} //namespace model
} //namespace dambase
