/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * RegressionFitAnalysisRegressorOverviewProvider.hpp
 *
 *  Created on: Mar 26, 2014
 *      Author: gerberma
 */

#ifndef REGRESSIONFITANALYSISREGRESSOROVERVIEWPROVIDER_HPP_
#define REGRESSIONFITANALYSISREGRESSOROVERVIEWPROVIDER_HPP_

#include <boost/shared_ptr.hpp>
#include "api/IRRegressionFitAnalysisRegressorOverview.hpp"
#include "api/IRegressionFitAnalysisRegressorOverviewProvider.hpp"

namespace dambase {
namespace model {
namespace r {


class RegressionFitAnalysisRegressorOverviewProvider : public api::IRegressionFitAnalysisRegressorOverviewProvider {
public:
	RegressionFitAnalysisRegressorOverviewProvider();
	virtual ~RegressionFitAnalysisRegressorOverviewProvider();

	boost::shared_ptr<api::IRRegressionFitAnalysisRegressorOverview> load(boost::shared_ptr<api::IRegressionFit> regressionFit);
};

}}} /* namespace dambase::model::r */


#endif /* REGRESSIONFITANALYSISREGRESSOROVERVIEWPROVIDER_HPP_ */
