/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * RegressionFitAnalysisResidualTimeSeriesProvider.cpp
 *
 *  Created on: 16.02.2015
 *      Author: gerberma
 */



#include "RRegressionFitAnalysisResidualTimeSeries.hpp"
#include "RegressionFitAnalysisResidualTimeSeriesProvider.hpp"

namespace dambase {
namespace model {
namespace r {

RegressionFitAnalysisResidualTimeSeriesProvider::RegressionFitAnalysisResidualTimeSeriesProvider(){;}
RegressionFitAnalysisResidualTimeSeriesProvider::~RegressionFitAnalysisResidualTimeSeriesProvider(){;}

boost::shared_ptr<api::IRRegressionFitAnalysisResidualTimeSeries>
RegressionFitAnalysisResidualTimeSeriesProvider::load(boost::shared_ptr<api::IRegressionFit> regressionFit) {
		using namespace Rcpp;
		Environment damBaseEnv("package:DamBASE");
		Function function = damBaseEnv["loadRegressionFitResidualTimeSeries"];

		List values = function(
					Named("regressionFit", regressionFit->getFit()),
					Named("regressionDataFrame", regressionFit->getRegressionFitDataFrame()->getDataFrame()),
					Named("regressionDateColumnNr", regressionFit->getRegressionFitDataFrame()->getDateColumn()->getIndex() + 1),

					Named("predictionBehaviorIndicatorColumnNr", regressionFit->getRegressionFormula()->getBehaviorIndicatorColumn()->getIndex() + 1),
					Named("predictionDataFrame", regressionFit->getRegressionFormula()->getDataFrame()->getDataFrame()),
					Named("predictionDateColumnNr", regressionFit->getRegressionFormula()->getDataFrame()->getDateColumn()->getIndex() + 1),
					Named("predictionStartDate", regressionFit->getRegressionFitDataFrame()->getDateColumn()->getFirstValue().getDate().toStdString()),

					Named("overallMaxStartupTime", regressionFit->getOverallMaxStartupTime())
				);

		boost::shared_ptr<RRegressionFitAnalysisResidualTimeSeries> result(new RRegressionFitAnalysisResidualTimeSeries(values));
		return result;
	}

} //namespace r
} //namespace model
} //namespace dambase
