/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * RegressionFitProvider.hpp
 *
 *  Created on: Feb 19, 2014
 *      Author: gerberma
 */

#ifndef REGRESSIONFITPROVIDER_HPP_
#define REGRESSIONFITPROVIDER_HPP_

#include "api/IRegressionFitProvider.hpp"
#include "RegressionFitDataFrame.hpp"
#include "RegressionFit.hpp"

namespace dambase {
namespace model {
namespace r {

class RegressionFitProvider : public api::IRegressionFitProvider {
public:
	RegressionFitProvider();
	virtual ~RegressionFitProvider();

	boost::shared_ptr<api::IRegressionFitProvider::RegressionFit_t> load(boost::shared_ptr<api::IRegressionFitProvider::RegressionFitDataFrame_t> regressionFitDataFrame, boost::shared_ptr<api::IRegressionFitProvider::RegressionFormula_t> formula);

	boost::shared_ptr<api::IRegressionFitProvider::RegressionFit_t> loadPraisWinsten(boost::shared_ptr<api::IRegressionFitProvider::RegressionFitDataFrame_t> regressionFitDataFrame,boost::shared_ptr<api::IRegressionFitProvider::RegressionFormula_t> formula, unsigned iterations);

	boost::shared_ptr<api::IRegressionFitProvider::RegressionFit_t> loadRidge(boost::shared_ptr<api::IRegressionFitProvider::RegressionFitDataFrame_t> regressionFitDataFrame, boost::shared_ptr<api::IRegressionFitProvider::RegressionFormula_t> formula, double k);

	boost::shared_ptr<api::IRegressionFitProvider::RegressionFit_t> loadPCR(boost::shared_ptr<api::IRegressionFitProvider::RegressionFitDataFrame_t> regressionFitDataFrame, boost::shared_ptr<api::IRegressionFitProvider::RegressionFormula_t> formula, unsigned r);

	boost::shared_ptr<api::IRegressionFitProvider::RegressionFitDataFrame_t> loadRegressionFitDataFrame(boost::shared_ptr<api::IRegressionFitProvider::DataFrame_t> dataFrame, boost::shared_ptr<api::IRegressionFitProvider::RegressionFormula_t> formula, QString fromDate, QString toDate);
};

}
}
} /* namespace dambase::model::r */



#endif /* REGRESSIONFITPROVIDER_HPP_ */
