/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * TemperatureColumn.hpp
 *
 *  Created on: Jan 14, 2014
 *      Author: gerberma
 */

#ifndef TEMPERATURECOLUMN_HPP_
#define TEMPERATURECOLUMN_HPP_

#include "DataFrameHeader.hpp"
#include "DataFrameColumn.hpp"

namespace dambase {
namespace model {
namespace r {

class TemperatureColumn : public DataFrameColumn {
public:
	typedef DataFrameColumn Base_t;
public:
	TemperatureColumn();
	TemperatureColumn(DataFrameHeader &dataFrameHeader);

};

inline model::r::TemperatureColumn::TemperatureColumn()
	:DataFrameColumn()
{
}

inline model::r::TemperatureColumn::TemperatureColumn(DataFrameHeader &dataFrameHeader)
	:DataFrameColumn(dataFrameHeader)
{
}

}
}
} /* namespace dambase::model::r */


#endif /* TEMPERATURECOLUMN_HPP_ */
