/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * TimeRange.hpp
 *
 *  Created on: Jun 2, 2014
 *      Author: gerberma
 */

#ifndef TIMERANGE_HPP_
#define TIMERANGE_HPP_

#include "api/ITimeRange.hpp"

namespace dambase {
namespace model {
namespace r {

class TimeRange : public virtual api::ITimeRange {
public:
	TimeRange(){;}

	TimeRange(api::ITimeRange::DateDataPoint_t fromDateDataPoint, api::ITimeRange::DateDataPoint_t toDateDataPoint)
		:fromDateDataPoint(fromDateDataPoint), toDateDataPoint(toDateDataPoint)
	{;}

	void setFromDate(api::ITimeRange::DateDataPoint_t fromDate);

	void setToDate(api::ITimeRange::DateDataPoint_t toDate);

	const api::ITimeRange::DateDataPoint_t &getFromDate() const;

	const api::ITimeRange::DateDataPoint_t &getToDate() const;

private:
	DateDataPoint_t fromDateDataPoint;
	DateDataPoint_t toDateDataPoint;
};

}  // namespace r
}  // namespace model
}  // namespace dambase


#endif /* TIMERANGE_HPP_ */
