/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * IDataFrameInfluenceFactorsProvider.hpp
 *
 *  Created on: 18.02.2015
 *      Author: gerberma
 */

#ifndef IDATAFRAMEINFLUENCEFACTORSPROVIDER_HPP_
#define IDATAFRAMEINFLUENCEFACTORSPROVIDER_HPP_

#include "IDataFrame.hpp"
#include "IDataFrameInfluenceFactors.hpp"

namespace dambase {
namespace model {
namespace r {
namespace api {

class IDataFrameInfluenceFactorsProvider {
public:
	typedef IDataFrameInfluenceFactors r_data_frame_influence_factors_type;
	typedef api::IDataFrame DataFrame_t;
	typedef DataFrame_t::Column_t Column_t;
public:
	IDataFrameInfluenceFactorsProvider(){;}
	virtual ~IDataFrameInfluenceFactorsProvider(){;}

	virtual boost::shared_ptr<api::IDataFrameInfluenceFactors> load(boost::shared_ptr<api::IDataFrameInfluenceFactorsProvider::DataFrame_t> dataFrame, boost::shared_ptr<api::IDataFrameInfluenceFactorsProvider::Column_t> behaviorIndicatorColumn, boost::shared_ptr<api::IDataFrameInfluenceFactorsProvider::Column_t> influenceFactorColumn) = 0;
};

} //namespace api
} //namespace r
} //namespace model
} //namespace


#endif /* IDATAFRAMEINFLUENCEFACTORSPROVIDER_HPP_ */
