/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * IDataFrameTimeSeriesOverview.hpp
 *
 *  Created on: 18.02.2015
 *      Author: gerberma
 */

#ifndef IDATAFRAMETIMESERIESOVERVIEW_HPP_
#define IDATAFRAMETIMESERIESOVERVIEW_HPP_

#include <vector>

namespace dambase {
namespace model {
namespace r {
namespace api {

class IDataFrameTimeSeriesOverview {
public:
	typedef std::vector<std::string> DateContainer_t;
	typedef std::vector<double> ValueContainer_t;
public:
	IDataFrameTimeSeriesOverview(){;}
	virtual ~IDataFrameTimeSeriesOverview(){;}

	virtual DateContainer_t &getDates() = 0;
	virtual ValueContainer_t &getValues() = 0;
};

} //namespace api
} //namespace r
} //namespace model
} //namespace


#endif /* IDATAFRAMETIMESERIESOVERVIEW_HPP_ */
