/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * IDataFrameTimeSeriesOverviewProvider.hpp
 *
 *  Created on: 18.02.2015
 *      Author: gerberma
 */

#ifndef IDATAFRAMETIMESERIESOVERVIEWPROVIDER_HPP_
#define IDATAFRAMETIMESERIESOVERVIEWPROVIDER_HPP_

#include <boost/shared_ptr.hpp>
#include "IDataFrameTimeSeriesOverview.hpp"

namespace dambase {
namespace model {
namespace r {
namespace api {

class IDataFrameTimeSeriesOverviewProvider {
public:
	typedef IDataFrameTimeSeriesOverview value_type;
	typedef IDataFrame DataFrame_t;
	typedef DataFrame_t::Column_t Column_t;
public:
	IDataFrameTimeSeriesOverviewProvider(){;}
	virtual ~IDataFrameTimeSeriesOverviewProvider(){;}

	/**
	 * dataFrame as well as further information about what to plot
	 */
	virtual boost::shared_ptr<api::IDataFrameTimeSeriesOverview> load(boost::shared_ptr<api::IDataFrameTimeSeriesOverviewProvider::DataFrame_t> dataFrame, boost::shared_ptr<api::IDataFrameTimeSeriesOverviewProvider::Column_t> valueColumn) = 0;
};

} //namespace api
} //namespace r
} //namespace model
} //namespace


#endif /* IDATAFRAMETIMESERIESOVERVIEWPROVIDER_HPP_ */
