/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * IRRegressionFitAnalysisACF.hpp
 *
 *  Created on: 09.02.2015
 *      Author: gerberma
 */

#ifndef IRREGRESSIONFITANALYSISACF_HPP_
#define IRREGRESSIONFITANALYSISACF_HPP_

#include <vector>

namespace dambase {
namespace model {
namespace r {
namespace api {

class IRRegressionFitAnalysisACF {
public:
	typedef std::vector<double> AcfContainer_t;
	typedef std::vector<unsigned> LagContainer_t;

	virtual AcfContainer_t &getAcfs() = 0;
	virtual LagContainer_t &getLags() = 0;
	virtual double getLowerCi() = 0;
	virtual double getUpperCi() = 0;

public:
	IRRegressionFitAnalysisACF(){;}
	virtual ~IRRegressionFitAnalysisACF(){;}
};

}  // namespace api
}  // namespace r
}  // namespace model
}  // namespace dambase


#endif /* IRREGRESSIONFITANALYSISACF_HPP_ */
