/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * IRRegressionFitAnalysisRegressionSummary.hpp
 *
 *  Created on: 09.02.2015
 *      Author: gerberma
 */

#ifndef IRREGRESSIONFITANALYSISREGRESSIONSUMMARY_HPP_
#define IRREGRESSIONFITANALYSISREGRESSIONSUMMARY_HPP_

namespace dambase {
namespace model {
namespace r {
namespace api {

class IRRegressionFitAnalysisRegressionSummary {
public:
	virtual double getSSRes() = 0;
	virtual double getMSRes() = 0;
	virtual double getMSResDerived() = 0;
	virtual double getR2() = 0;
	virtual double getR2Adj() = 0;
	virtual double getFStat() = 0;
	virtual double getFStatPValue() = 0;
	virtual double getDwStat() = 0;
	virtual double getNobs() = 0;
	virtual double getSSResPred() = 0;
	virtual double getMSResDerivedPred() = 0;
public:
	IRRegressionFitAnalysisRegressionSummary(){;}
	virtual ~IRRegressionFitAnalysisRegressionSummary(){;}
};

} //namespace api
} //namespace r
} //namespace model
} //namespace


#endif /* IRREGRESSIONFITANALYSISREGRESSIONSUMMARY_HPP_ */
