/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * IRRegressionFitAnalysisRegressorOverview.hpp
 *
 *  Created on: 18.02.2015
 *      Author: gerberma
 */

#ifndef IRREGRESSIONFITANALYSISREGRESSOROVERVIEW_HPP_
#define IRREGRESSIONFITANALYSISREGRESSOROVERVIEW_HPP_

#include <QString>

namespace dambase {
namespace model {
namespace r {
namespace api {

class IRRegressionFitAnalysisRegressorOverviewItem {
public:
	IRRegressionFitAnalysisRegressorOverviewItem(){;}
	virtual ~IRRegressionFitAnalysisRegressorOverviewItem(){;}

	virtual double getCoefficient() = 0;
	virtual double getTStat() = 0;
	virtual double getPValue() = 0;
	virtual double getVIF() = 0;
	virtual double getStdError() = 0;
	virtual double getStdCoefficient() = 0;
};

class IRRegressionFitAnalysisRegressorOverviewRegressorItem : public virtual IRRegressionFitAnalysisRegressorOverviewItem {
public:
	IRRegressionFitAnalysisRegressorOverviewRegressorItem(){;}
	virtual ~IRRegressionFitAnalysisRegressorOverviewRegressorItem(){;}

	virtual QString getName() = 0;
	virtual bool isActive() = 0;
	virtual bool isEditable() = 0;
	virtual int getRegressorIndex() = 0;

	virtual double getCoefficient() = 0;
	virtual double getTStat() = 0;
	virtual double getPValue() = 0;
	virtual double getVIF() = 0;
	virtual double getStdError() = 0;
	virtual double getStdCoefficient() = 0;
};

class IRRegressionFitAnalysisRegressorOverviewInterceptItem : public virtual IRRegressionFitAnalysisRegressorOverviewItem {
public:
	IRRegressionFitAnalysisRegressorOverviewInterceptItem(){;}
	virtual ~IRRegressionFitAnalysisRegressorOverviewInterceptItem(){;}

	virtual QString getName() = 0;

	virtual double getCoefficient() = 0;
	virtual double getTStat() = 0;
	virtual double getPValue() = 0;
	virtual double getVIF() = 0;
	virtual double getStdError() = 0;
	virtual double getStdCoefficient() = 0;
};

class IRRegressionFitAnalysisRegressorOverview {
public:
	typedef IRRegressionFitAnalysisRegressorOverviewRegressorItem RegressorItem_t;
	typedef std::vector<boost::shared_ptr<RegressorItem_t> > RegressorItemContainer_t;
	typedef IRRegressionFitAnalysisRegressorOverviewInterceptItem InterceptItem_t;
public:
	IRRegressionFitAnalysisRegressorOverview(){;}
	virtual ~IRRegressionFitAnalysisRegressorOverview(){;}

	virtual RegressorItemContainer_t getRegressorItems() = 0;
	virtual boost::shared_ptr<InterceptItem_t> getInterceptItem() = 0;
};

} //namespace api
} //namespace r
} //namespace model
} //namespace


#endif /* IRREGRESSIONFITANALYSISREGRESSOROVERVIEW_HPP_ */
