/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * IRRegressionFitAnalysisResidualVersusRegressionParameter.hpp
 *
 *  Created on: 09.02.2015
 *      Author: gerberma
 */

#ifndef IRREGRESSIONFITANALYSISRESIDUALVERSUSREGRESSIONPARAMETER_HPP_
#define IRREGRESSIONFITANALYSISRESIDUALVERSUSREGRESSIONPARAMETER_HPP_

namespace dambase {
namespace model {
namespace r {
namespace api {

class IRRegressionFitAnalysisResidualVersusRegressionParameter {
public:
	typedef std::vector<double> ResidualContainer_t;
	typedef std::vector<double> ParameterValueContainer_t;
public:
	virtual ResidualContainer_t &getResiduals() = 0;
	virtual ParameterValueContainer_t &getParameterValues() = 0;
public:
	IRRegressionFitAnalysisResidualVersusRegressionParameter(){;}
	virtual ~IRRegressionFitAnalysisResidualVersusRegressionParameter(){;}
};

} //namespace api
} //namespace r
} //namespace model
} //namespace


#endif /* IRREGRESSIONFITANALYSISRESIDUALVERSUSREGRESSIONPARAMETER_HPP_ */
