/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * IRegressionFit.hpp
 *
 *  Created on: 16.02.2015
 *      Author: gerberma
 */

#ifndef IREGRESSIONFIT_HPP_
#define IREGRESSIONFIT_HPP_

#include <boost/shared_ptr.hpp>
#include <Rcpp.h>
#include "IRegressor.hpp"
#include "IRegressionFormula.hpp"
#include "IRegressionFitDataFrame.hpp"

namespace dambase {
namespace model {
namespace r {
namespace api {

class IRegressionFit {
public:
	typedef IRegressionFormula RegressionFormula_t;
	typedef IRegressionFitDataFrame RegressionFitDataFrame_t;
public:
	IRegressionFit(){;}
	virtual ~IRegressionFit(){;}

	//virtual double getCoefficientFor(boost::shared_ptr<IRegressor> regressor) = 0;

	virtual double getIntercept() = 0;

	virtual Rcpp::List getFit() = 0;

	virtual boost::shared_ptr<RegressionFormula_t> getRegressionFormula() = 0;

	virtual boost::shared_ptr<RegressionFitDataFrame_t> getRegressionFitDataFrame() = 0;

	virtual int getOverallMaxStartupTime() = 0;

	virtual double getPraisWinstenRho() = 0;
};

} //namespace api
} //namespace r
} //namespace model
} //namespace


#endif /* IREGRESSIONFIT_HPP_ */
