/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * IRegressionFitAnalysisPhysicalBehaviorProvider.hpp
 *
 *  Created on: 16.02.2015
 *      Author: gerberma
 */

#ifndef IREGRESSIONFITANALYSISPHYSICALBEHAVIORPROVIDER_HPP_
#define IREGRESSIONFITANALYSISPHYSICALBEHAVIORPROVIDER_HPP_

#include <boost/shared_ptr.hpp>
#include <Rcpp.h>
#include "IDataFrame.hpp"
#include "IRegressionFit.hpp"
#include "IRRegressionFitAnalysisPhysicalBehavior.hpp"

namespace dambase {
namespace model {
namespace r {
namespace api {

class IRegressionFitAnalysisPhysicalBehaviorProvider {
public:
	typedef IRRegressionFitAnalysisPhysicalBehavior value_type;
public:
	IRegressionFitAnalysisPhysicalBehaviorProvider(){;}
	virtual ~IRegressionFitAnalysisPhysicalBehaviorProvider(){;}

	virtual boost::shared_ptr<IRRegressionFitAnalysisPhysicalBehavior> load(boost::shared_ptr<IRegressionFit> regressionFit,
				Rcpp::Formula formula,
				Rcpp::DataFrame &dataFrame,
				boost::shared_ptr<IDataFrame::DateColumn_t> dateColumn,
				QString startDate,
				QString endDate,
				int overallMaxStartupTime,
				boost::shared_ptr<IDataFrame::Column_t> response,
				QString name,
				bool doApplyCoefficientsAndIntercept = true) = 0;
};

} //namespace api
} //namespace r
} //namespace model
} //namespace


#endif /* IREGRESSIONFITANALYSISPHYSICALBEHAVIORPROVIDER_HPP_ */
