/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * IRegressionFitAnalysisRegressorOverviewProvider.hpp
 *
 *  Created on: 18.02.2015
 *      Author: gerberma
 */

#ifndef IREGRESSIONFITANALYSISREGRESSOROVERVIEWPROVIDER_HPP_
#define IREGRESSIONFITANALYSISREGRESSOROVERVIEWPROVIDER_HPP_

#include <boost/shared_ptr.hpp>
#include "IRegressionFit.hpp"
#include "IRRegressionFitAnalysisRegressorOverview.hpp"

namespace dambase {
namespace model {
namespace r {
namespace api {

class IRegressionFitAnalysisRegressorOverviewProvider {
public:
	typedef IRRegressionFitAnalysisRegressorOverview value_type;
public:
	IRegressionFitAnalysisRegressorOverviewProvider(){;}
	virtual ~IRegressionFitAnalysisRegressorOverviewProvider(){;}

	virtual boost::shared_ptr<IRRegressionFitAnalysisRegressorOverview> load(boost::shared_ptr<IRegressionFit> regressionFit) = 0;
};

} //namespace api
} //namespace r
} //namespace model
} //namespace

#endif /* IREGRESSIONFITANALYSISREGRESSOROVERVIEWPROVIDER_HPP_ */
