/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * IRegressionFitAnalysisResidualNormalProbabilityProvider.hpp
 *
 *  Created on: 16.02.2015
 *      Author: gerberma
 */

#ifndef IREGRESSIONFITANALYSISRESIDUALNORMALPROBABILITYPROVIDER_HPP_
#define IREGRESSIONFITANALYSISRESIDUALNORMALPROBABILITYPROVIDER_HPP_

#include <boost/shared_ptr.hpp>
#include "IRegressionFit.hpp"
#include "IRRegressionFitAnalysisResidualNormalProbability.hpp"

namespace dambase {
namespace model {
namespace r {
namespace api {

class IRegressionFitAnalysisResidualNormalProbabilityProvider {
public:
	typedef api::IRRegressionFitAnalysisResidualNormalProbability value_type;
public:
	IRegressionFitAnalysisResidualNormalProbabilityProvider(){;}
	virtual ~IRegressionFitAnalysisResidualNormalProbabilityProvider(){;}

	virtual boost::shared_ptr<IRRegressionFitAnalysisResidualNormalProbability> load(boost::shared_ptr<IRegressionFit> regressionFit) = 0;
};

} //namespace api
} //namespace r
} //namespace model
} //namespace


#endif /* IREGRESSIONFITANALYSISRESIDUALNORMALPROBABILITYPROVIDER_HPP_ */
