/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * IRegressionFitDataFrame.hpp
 *
 *  Created on: 16.02.2015
 *      Author: gerberma
 */

#ifndef IREGRESSIONFITDATAFRAME_HPP_
#define IREGRESSIONFITDATAFRAME_HPP_

#include <boost/shared_ptr.hpp>
#include <vector>
#include <Rcpp.h>
#include "model/r/DataFrameHeader.hpp"
#include "model/r/DataFrameColumn.hpp"
#include "model/r/DateColumn.hpp"
#include "model/r/BehaviorIndicatorColumn.hpp"

namespace dambase {
namespace model {
namespace r {
namespace api {

class IRegressionFitDataFrame {
public:
	typedef model::r::DataFrameHeader DataFrameHeader_t;
	typedef model::r::BehaviorIndicatorColumn BehaviorIndicatorColumn_t;
	typedef model::r::DateColumn DateColumn_t;
public:
	IRegressionFitDataFrame(){;}
	virtual ~IRegressionFitDataFrame(){;}

	virtual Rcpp::DataFrame &getDataFrame() = 0;

	virtual boost::shared_ptr<DateColumn_t> getDateColumn() = 0;

	virtual std::vector<DataFrameHeader_t> &getHeaders() = 0;

	virtual boost::shared_ptr<BehaviorIndicatorColumn_t> getBehaviorIndicatorColumn() = 0;

	virtual int getOverallMaxStartupTime() = 0;
};

} //namespace api
} //namespace r
} //namespace model
} //namespace


#endif /* IREGRESSIONFITDATAFRAME_HPP_ */
