/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * IRegressorFormulaBuilderPreprocessor.hpp
 *
 *  Created on: 16.02.2015
 *      Author: gerberma
 */

#ifndef IREGRESSORFORMULABUILDERPREPROCESSOR_HPP_
#define IREGRESSORFORMULABUILDERPREPROCESSOR_HPP_

namespace dambase {
namespace model {
namespace r {
namespace api {

class IRegressorFormulaBuilderPreprocessor {
public:
public:
	IRegressorFormulaBuilderPreprocessor():isactive(true){;}
	virtual ~IRegressorFormulaBuilderPreprocessor(){;}

	virtual QString resolveFormula() = 0;

	/**
	 * A concrete implementation can disable the editing of the active state of this preprocessor depending on any other condition.
	 * For example: on the WaterLevelMin/Max preprocessor, the editing can be disabled if the user has disabled the entire min/max water level feature on the analysis
	 */
	virtual const bool &isEnabled() const = 0;

	virtual const bool &isActive() const {
		return isactive;
	}

	virtual void setIsActive(bool isActive) {
		this->isactive = isActive;
	}

	virtual const QString &getName() const = 0;

protected:
	bool isactive;
};

} //namespace api
} //namespace r
} //namespace model
} //namespace


#endif /* IREGRESSORFORMULABUILDERPREPROCESSOR_HPP_ */
