/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * ITimeRange.hpp
 *
 *  Created on: 16.02.2015
 *      Author: gerberma
 */

#ifndef ITIMERANGE_HPP_
#define ITIMERANGE_HPP_

#include "model/r/DateDataPoint.hpp"

namespace dambase {
namespace model {
namespace r {
namespace api {

class ITimeRange {
public:
	typedef DateDataPoint DateDataPoint_t;
public:
	ITimeRange(){;}
	virtual ~ITimeRange(){;}

	virtual void setFromDate(DateDataPoint_t fromDate) = 0;

	virtual void setToDate(DateDataPoint_t toDate) = 0;

	virtual const DateDataPoint_t &getFromDate() const = 0;

	virtual const DateDataPoint_t &getToDate() const = 0;
};

} //namespace api
} //namespace r
} //namespace model
} //namespace


#endif /* ITIMERANGE_HPP_ */
