/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * converter.cpp
 *
 *  Created on: Dec 18, 2013
 *      Author: gerberma
 */


#include <vector>
#include <Rcpp.h>
#include <RcppCommon.h>


#include "DataFrame.hpp"
#include "DataFrameOverviewStatistics.hpp"

namespace Rcpp {
template<>
dambase::model::r::DataFrame* as(SEXP dfsexp) {
	Rcpp::DataFrame rcppDataFrame(dfsexp);

	dambase::model::r::DataFrame *dataFrame = new dambase::model::r::DataFrame(rcppDataFrame);

	return dataFrame;
}

template<>
dambase::model::r::DataFrameOverviewStatistics *as(SEXP statsexp) {
	Rcpp::List rcppList(statsexp);

	dambase::model::r::DataFrameOverviewStatistics *overviewStatistics = new dambase::model::r::DataFrameOverviewStatistics(rcppList);

	return overviewStatistics;
}


}


