/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * GenericRegressorFormulaBuilder.h
 *
 *  Created on: Jun 3, 2014
 *      Author: gerberma
 */

#ifndef GENERICREGRESSIONFORMULABUILDER_H_
#define GENERICREGRESSIONFORMULABUILDER_H_

#include <boost/shared_ptr.hpp>
#include <QString>
#include "model/r/DataFrameColumn.hpp"

namespace model {
namespace r {

template<typename _DataFrameColumn = ::dambase::model::r::DataFrameColumn>
class GenericRegressorFormulaBuilder {
public:
	typedef _DataFrameColumn Influence_Factor_t;
public:
	GenericRegressorFormulaBuilder(QString originalFormula, boost::shared_ptr<Influence_Factor_t> influenceFactor)
		:originalFormula(originalFormula), influenceFactor(influenceFactor){;}

	virtual ~GenericRegressorFormulaBuilder(){;}

	QString getFormula() {
		return originalFormula;
	}

	boost::shared_ptr<Influence_Factor_t> getInfluenceFactor() {
		return influenceFactor;
	}

private:
	QString originalFormula;
	boost::shared_ptr<_DataFrameColumn> influenceFactor;
};

} /* namespace r */
} /* namespace model */
#endif /* GENERICREGRESSIONFORMULABUILDER_H_ */
