/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * XmlSerialization.hpp
 *
 *  Created on: Nov 21, 2013
 *      Author: gerberma
 */

#ifndef XMLSERIALIZATION_HPP_
#define XMLSERIALIZATION_HPP_

#include <iostream>
#include <fstream>
#include <cstdio> // remove
#include <boost/config.hpp>
#include <boost/shared_ptr.hpp>
#if defined(BOOST_NO_STDC_NAMESPACE)
namespace std {
	using ::remove;
}
#endif

#include <boost/archive/xml_iarchive.hpp>
#include <boost/archive/xml_oarchive.hpp>
#include <boost/serialization/shared_ptr.hpp>
#include "model/Project.hpp"

namespace persistence {

class XmlSerializationPolicy {
public:
	XmlSerializationPolicy();
	virtual ~XmlSerializationPolicy();

	template<typename T>
	void serialize(boost::shared_ptr<T> t, QString filename);
	template<typename T>
	void deserialize(boost::shared_ptr<T>& t, QString filename);

private:
	void registerDerivedBasePairs();
};

/*
inline XmlSerializationPolicy<T>::XmlSerializationPolicy() {
}

inline XmlSerializationPolicy<T>::~XmlSerializationPolicy() {
}

template<typename T>
inline void XmlSerializationPolicy::serialize(boost::shared_ptr<T> t, QString filename) {
	std::ofstream ofs(filename.toStdString().c_str());
	boost::archive::xml_oarchive oa(ofs);

	//boost::shared_ptr<dambase::model::Project> project = boost::static_pointer_cast<dambase::model::Project>(t);
	oa << BOOST_SERIALIZATION_NVP(t);

	std::cout << "saved to " << filename.toStdString() << std::endl;
}


template<typename T>
inline void XmlSerializationPolicy::deserialize(boost::shared_ptr<T>& t, QString filename) {
	std::ifstream ifs(filename.toStdString().c_str());
	boost::archive::xml_iarchive ia(ifs);
	ia >> BOOST_SERIALIZATION_NVP(t);
}
*/

} /* namespace persistence */

#endif /* XMLSERIALIZATION_HPP_ */
