/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * AnalysisToolsControllerSubscriptionManager.hpp
 *
 *  Created on: Mar 20, 2014
 *      Author: gerberma
 */

#ifndef ANALYSISTOOLSCONTROLLERSUBSCRIPTIONMANAGER_HPP_
#define ANALYSISTOOLSCONTROLLERSUBSCRIPTIONMANAGER_HPP_

#include <boost/bind.hpp>
#include <boost/shared_ptr.hpp>
#include "communication/Signals.hpp"

namespace subscription {

class AnalysisToolsControllerSubscriptionManager{
public:
	AnalysisToolsControllerSubscriptionManager(){;}
	virtual ~AnalysisToolsControllerSubscriptionManager(){;}


	template<typename Controller, typename OverviewUi, typename T>
	void subscribe(Controller *controller, OverviewUi *overviewUi, boost::shared_ptr<T> t) {
		using namespace boost;

		COM_SUBSCRIBE_FOR(overviewUi, RemoveAnalysisTool, (bind<void>(&Controller::template removeAnalysisTool<T>, controller, t, _1)));
	}
};

} /* namespace subscription */


#endif /* ANALYSISTOOLSCONTROLLERSUBSCRIPTIONMANAGER_HPP_ */
