/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * DataModelAnalysisToolsTimeSeriesOverviewControllerSubscriptionManager.hpp
 *
 *  Created on: Mar 11, 2014
 *      Author: gerberma
 */

#ifndef DATAMODELANALYSISTOOLSTIMESERIESOVERVIEWCONTROLLERSUBSCRIPTIONMANAGER_HPP_
#define DATAMODELANALYSISTOOLSTIMESERIESOVERVIEWCONTROLLERSUBSCRIPTIONMANAGER_HPP_

#include <boost/bind.hpp>
#include <boost/shared_ptr.hpp>
#include "communication/Signals.hpp"
#include "AnalysisToolsControllerSubscriptionManager.hpp"

namespace subscription {

template
<
	typename OverviewUi
>
class DataModelAnalysisToolsTimeSeriesOverviewControllerSubscriptionManager {
public:
	DataModelAnalysisToolsTimeSeriesOverviewControllerSubscriptionManager()
	{;}

	virtual ~DataModelAnalysisToolsTimeSeriesOverviewControllerSubscriptionManager()
	{;}


	template<typename Controller, typename Analysis>
	void subscribe(Controller *controller, OverviewUi *overviewUi, boost::shared_ptr<Analysis> analysis) {
		internal.subscribe(controller, overviewUi, analysis);
	}

	template<typename Controller>
	void subscribe(Controller *controller, typename OverviewUi::configuration_widget_t *configurationUi) {
		using namespace boost;

		COM_SUBSCRIBE_FOR(configurationUi, ValueColumnChanged, (bind(&Controller::valueColumnChanged, controller, _1, _2)));
	}

private:
	 AnalysisToolsControllerSubscriptionManager internal;
};

}  // namespace subscription


#endif /* DATAMODELANALYSISTOOLSTIMESERIESOVERVIEWCONTROLLERSUBSCRIPTIONMANAGER_HPP_ */
