/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * SignalsTests.cpp
 *
 *  Created on: Jan 9, 2014
 *      Author: gerberma
 */

#define BOOST_TEST_MODULE AnalysisControllerTests
#include <boost/test/unit_test.hpp>
#include <turtle/mock.hpp>
#include <turtle/constraints.hpp>
#include <boost/bind.hpp>
#include <boost/ref.hpp>
#include "communication/Signals.hpp"

MOCK_CLASS(Subscriber){
	void targetFunction() {
		targetFunctionDelegate();
	}
	MOCK_METHOD_EXT(targetFunctionDelegate, 0, void(), targetFunctionDelegate);
};

class Target
{
public:
	COM_SUBSCRIPTION_FUNCTION(aSignal, communication::SimpleChangedSignal::signal_t)
	void fire() {
		aSignalSignal();
	}
};

BOOST_AUTO_TEST_CASE(testSignalSubscription) {
	Target target;
	Subscriber subscriber;
	COM_SUBSCRIBE_FOR_REFERENCE(target, aSignal, (boost::bind<void>(&Subscriber::targetFunction, &subscriber)));

	MOCK_EXPECT(subscriber.targetFunctionDelegate).once();

	target.fire();
}
