/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * DataModelAnalysisTimeSeriesOverviewDisplayWidgetTest.cpp
 *
 *  Created on: Jun 24, 2014
 *      Author: gerberma
 */


#include <vector>
#include <string>
#include <QWidget>
#include "gui/DataModelAnalysisTimeSeriesOverviewDisplayWidget.hpp"
#include "GuiAnalysisToolApplicationContext.hpp"
#include "communication/Signals.hpp"

namespace test {

struct ConfigurationWidget : public QWidget {
};

struct TimeSeriesOverview {
	typedef std::vector<std::string> DateContainer_t;
	typedef std::vector<double> ValueContainer_t;

	DateContainer_t getDates() {
		return dates;
	}

	ValueContainer_t getValues() {
		return values;
	}

	QString getValueColumnName() {
		return columnName;
	}

	DateContainer_t dates;
	ValueContainer_t values;
	QString columnName;

	COM_SUBSCRIPTION_FUNCTION(Loaded, communication::Signal<void()>);
};


} // namespace test


int
main(int argc, char *argv[]) {
	typedef gui::DataModelAnalysisTimeSeriesOverviewDisplayWidget<test::TimeSeriesOverview, test::ConfigurationWidget> widget_t;
	test::helper::GuiAnalysisToolApplicationContext<test::TimeSeriesOverview, widget_t, test::helper::CallInitPolicy<widget_t> > appCtx;

	test::TimeSeriesOverview::DateContainer_t dates;
	test::TimeSeriesOverview::ValueContainer_t values;

	values.push_back(1047);
	values.push_back(1043);
	values.push_back(1045);
	values.push_back(1040);

	dates.push_back("1983-08-11");
	dates.push_back("1984-08-12");
	dates.push_back("1985-08-13");
	dates.push_back("1986-08-14");

	appCtx.t.dates = dates;
	appCtx.t.values = values;
	appCtx.t.columnName = "MSVC1";


	return appCtx.run(argc, argv);
}
