/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * RegressionModelDataOverviewWidgetTest.cpp
 *
 *  Created on: Mar 5, 2014
 *      Author: gerberma
 */


#include <QApplication>
#include <QMainWindow>
#include <QWidget>
#include <QLabel>
#include <QVBoxLayout>
#include "gui/DataOverviewWidget.hpp"
#include "app/GenericApplicationContext.hpp"

using namespace app::context;

template<int Separator>
class AnyWidgetWithALabel : public QWidget
{
public:
	AnyWidgetWithALabel() {
		setupLayout();
	}

	void setupLayout() {
		QVBoxLayout *widgetLayout = new QVBoxLayout(this);
		widgetLayout->addWidget(new QLabel("hello world"));
		setLayout(widgetLayout);
	}
};


typedef gui::DataOverviewWidget<1> DataOverviewWidget_t;

DataOverviewWidget_t *factory() {
	std::vector<QWidget *> widgets;
	widgets.push_back(FETCH_FROM_CTX(AnyWidgetWithALabel<1>));
	widgets.push_back(FETCH_FROM_CTX(AnyWidgetWithALabel<2>));
	return new DataOverviewWidget_t(widgets);
}

int
main(int argc, char *argv[]) {
	QApplication app(argc, argv);
	QMainWindow mainWindow;

	REGISTER_FULL_CTX(AnyWidgetWithALabel<1>, defaultFactory<AnyWidgetWithALabel<1> >, defaultCleanupStrategy<AnyWidgetWithALabel<1> >);
	REGISTER_FULL_CTX(AnyWidgetWithALabel<2>, defaultFactory<AnyWidgetWithALabel<2> >, defaultCleanupStrategy<AnyWidgetWithALabel<2> >);
	REGISTER_FULL_CTX(DataOverviewWidget_t, factory, defaultCleanupStrategy<DataOverviewWidget_t>);

	mainWindow.setCentralWidget(FETCH_FROM_CTX(DataOverviewWidget_t));
	mainWindow.show();

 return app.exec();
}
