/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * RegressionFitAnalysisOverallRegressionQualityDisplayWidgetTest.cpp
 *
 *  Created on: Apr 16, 2014
 *      Author: gerberma
 */


#include <QApplication>
#include <QMainWindow>
#include <QVector>
#include "gui/RegressionFitAnalysisOverallRegressionQualityDisplayWidget.hpp"
#include "communication/Signals.hpp"
#include "app/GenericApplicationContext.hpp"

using namespace app::context;

namespace test {

struct Quality {
	int getAutocorrelationDegree() {
		return 0;
	}

	double getAutocorrelationValue() {
		return 2.05;
	}

	int getFitDegree() {
		return 1;
	}

	double getFitValue() {
		return 0.96;
	}
};

} //namespace test

typedef gui::RegressionFitAnalysisOverallRegressionQualityDisplayWidget<test::Quality> Widget_t;

Widget_t *factory() {
	return new Widget_t(FETCH_FROM_CTX(test::Quality));
}


int
main(int argc, char *argv[]) {
	QApplication app(argc, argv);
	QMainWindow mainWindow;

	REGISTER_FULL_CTX(Widget_t, factory, defaultCleanupStrategy<Widget_t>);
	REGISTER_FULL_DEFAULT_CTX(test::Quality);

	Widget_t *widget = FETCH_FROM_CTX(Widget_t);
	mainWindow.setCentralWidget(widget);

	mainWindow.show();

 return app.exec();
}

