/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * RegressionModelTimeRangeDisplayWidgetTest.cpp
 *
 *  Created on: Mar 5, 2014
 *      Author: gerberma
 */


#include <QApplication>
#include <QMainWindow>
#include "gui/RegressionModelTimeRangeDisplayWidget.hpp"
#include "app/GenericApplicationContext.hpp"

using namespace app::context;

namespace test {
struct DateDataPoint {
	DateDataPoint(){;}

	DateDataPoint(QString date):date(date){;}

	QString getDate() {
		return date;
	}

	QString date;
};

struct RegressionModel {
	DateDataPoint& getFromDate() {
		return fromDate;
	}

	DateDataPoint& getToDate() {
		return toDate;
	}

	DateDataPoint fromDate;
	DateDataPoint toDate;
};
}  // namespace test

typedef gui::RegressionModelTimeRangeDisplayWidget<test::RegressionModel> Widget_t;

test::RegressionModel *regressionModelFactory() {
	test::RegressionModel *regressionModel = new test::RegressionModel();

	regressionModel->fromDate = test::DateDataPoint("11.08.1983");
	regressionModel->toDate = test::DateDataPoint("12.08.1983");

	return regressionModel;
}

Widget_t *factory() {
	return new Widget_t(FETCH_FROM_CTX(test::RegressionModel));
}

int
main(int argc, char *argv[]) {
	QApplication app(argc, argv);
	QMainWindow mainWindow;

	REGISTER_FULL_CTX(Widget_t, factory, defaultCleanupStrategy<Widget_t>);
	REGISTER_FULL_CTX(test::RegressionModel, regressionModelFactory, defaultCleanupStrategy<test::RegressionModel>);

	mainWindow.setCentralWidget(FETCH_FROM_CTX(Widget_t));
	mainWindow.show();

	return app.exec();
}

