/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * TwoSideNamedWidgetTest.cpp
 *
 *  Created on: Mar 5, 2014
 *      Author: gerberma
 */

#include <QApplication>
#include <QMainWindow>
#include <QString>
#include <QWidget>
#include <boost/bind.hpp>
#include "gui/TwoSideNamedWidget.hpp"
#include "app/GenericApplicationContext.hpp"
#include "communication/Signals.hpp"

using namespace app::context;

class LeftWidget : public QWidget
{};

class RightWidget : public QWidget
{};

typedef gui::TwoSideNamedWidget<LeftWidget, RightWidget> Two_Side_Named_Widget_t;

Two_Side_Named_Widget_t *factory() {
	return new Two_Side_Named_Widget_t(
				FETCH_FROM_CTX(LeftWidget), "leftWidget",
				FETCH_FROM_CTX(RightWidget), "rightWidget"
			);
}

int
main(int argc, char *argv[]) {
	QApplication app(argc, argv);
	QMainWindow mainWindow;

	REGISTER_FULL_CTX(LeftWidget, defaultFactory<LeftWidget>, defaultCleanupStrategy<LeftWidget>);
	REGISTER_FULL_CTX(RightWidget, defaultFactory<RightWidget>, defaultCleanupStrategy<RightWidget>);

	REGISTER_FULL_CTX(Two_Side_Named_Widget_t, factory, defaultCleanupStrategy<Two_Side_Named_Widget_t>);
	/*
	REGISTER_FULL_CTX(RegressionModel_Overview_Widget_t, factory, defaultCleanupStrategy<RegressionModel_Overview_Widget_t>);

	mainWindow.setCentralWidget(FETCH_FROM_CTX(RegressionModel_Overview_Widget_t));
	*/

	mainWindow.setCentralWidget(FETCH_FROM_CTX(Two_Side_Named_Widget_t));
	mainWindow.show();

 return app.exec();
}


