/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * GenericApplicationContextTestHelper.hpp
 *
 *  Created on: Nov 26, 2013
 *      Author: gerberma
 */

#ifndef GENERICAPPLICATIONCONTEXTTESTHELPER_HPP_
#define GENERICAPPLICATIONCONTEXTTESTHELPER_HPP_

#include "app/GenericApplicationContext.hpp"

namespace test {
namespace helper {

/**
 * The following is an example for how to use this helper macros to define
 * a testcase fixture which acts as a registrar and scope container for test objects
 */
/*

//define the testcase fixture
class TestcaseFixture {
public:
	TestcaseFixture() :
		GAC_PARTIAL_CTOR_INIT_WITH_FACTORY(CoreController_t, coreControllerFactory),
		GAC_DEFAULT_CTOR_INIT(CoreUiMock),
		GAC_DEFAULT_CTOR_INIT(ModelMock)
	{}

private:
	GAC_SCOPE(CoreController_t)
	GAC_SCOPE(CoreUiMock)
	GAC_SCOPE(ModelMock)
};

//use the testcase fixture
BOOST_FIXTURE_TEST_CASE(TestStartCoreWindowOnStart, TestcaseFixture)
{
	CoreController_t *coreController = FETCH_FROM_CTX(CoreController_t);

	MOCK_EXPECT(FETCH_FROM_CTX(CoreUiMock)->start).once();

	coreController->start();
}

*/

/*
#define GAC_SCOPE(CLASS) \
	const GenericApplicationContextScope<GenericApplicationContext<CLASS> > scope##CLASS;
#define GAC_DEFAULT_CTOR_INIT(CLASS) \
	scope##CLASS(registerCtxWithContextScope<GenericApplicationContext<CLASS>, CLASS>())
*/
#define GAC_PARTIAL_CTOR_INIT_WITH_FACTORY(CLASS, FACTORY) \
	scope##CLASS(registerCtxWithContextScope<GenericApplicationContext<CLASS>, CLASS>(FACTORY))
#define GAC_FULL_CTOR_INIT(CLASS, FACTORY, CLEANUP) \
	scope##CLASS(registerCtxWithContextScope<GenericApplicationContext<CLASS>, CLASS>(FACTORY, CLEANUP))

}} /* namespace test::helper */


#endif /* GENERICAPPLICATIONCONTEXTTESTHELPER_HPP_ */
