/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * RApplicationContext.hpp
 *
 *  Created on: Feb 26, 2014
 *      Author: gerberma
 */

#ifndef RAPPLICATIONCONTEXT_HPP_
#define RAPPLICATIONCONTEXT_HPP_


#include "model/r/RManager.hpp"
#include "app/GenericApplicationContext.hpp"
#include "tests/helper/GenericApplicationContextTestHelper.hpp"


namespace test {

class RApplicationContext {
public:
	RApplicationContext()
		:rManagerScope(app::context::registerCtxWithContextScope<app::context::GenericApplicationContext<model::r::RManager>, model::r::RManager>(app::context::defaultFactory<model::r::RManager>))
	{
		app::context::GenericApplicationContext<model::r::RManager>::get();
	}

private:
	model::r::RManager *rManagerFactory() {
		return new model::r::RManager();
	}

private:
	app::context::GenericApplicationContextScope<app::context::GenericApplicationContext<model::r::RManager> > rManagerScope;
};

} /* namespace test */


#endif /* RAPPLICATIONCONTEXT_HPP_ */
