/*
    DamBASE - Dam Behaviour Analysis Software Environment
    Copyright (C) 2015   VAW, ETH Zurich, Gerber M., Buehlmann M.,
    Vetsch D.F., 2015
    http://www.dambase.ethz.ch

    This file is part of DamBASE

    DamBASE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DamBASE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * RandomPlotLocationGeneratorPolicyTests.cpp
 *
 *  Created on: Jan 30, 2014
 *      Author: gerberma
 */

#define BOOST_TEST_MODULE RRandomPlotLocationGeneratorPolicyTests

#include <boost/test/unit_test.hpp>
#include <boost/regex.hpp>
#include <QString>
#include <iostream>
#include "model/r/RandomPlotLocationGeneratorPolicy.hpp"


BOOST_AUTO_TEST_CASE(TestForRandomness) {
	model::r::RandomPlotLocationGeneratorPolicy policy("c:/tmp");

	QString firstPlotLocation = policy.getPlotLocation();
	QString secondPlotLocation = policy.getPlotLocation();

	BOOST_CHECK(firstPlotLocation != secondPlotLocation);
}

BOOST_AUTO_TEST_CASE(TestFilePattern) {
	model::r::RandomPlotLocationGeneratorPolicy policy("c:/tmp");

	std::cout << policy.getPlotLocation().toStdString() << std::endl;

	boost::regex expression("^c:/tmp/.*.svg$");
	BOOST_CHECK(boost::regex_match(policy.getPlotLocation().toStdString().c_str(), expression));
}
